/* MetadataWriter.c generated by valac 0.56.14, the Vala compiler
 * generated from MetadataWriter.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* MetadataWriter tracks LibraryPhotos for alterations to their metadata and commits those changes*/
/* in a timely manner to their backing files.  Because only the MetadataWriter knows when the*/
/* metadata has been properly committed, it is also responsible for updating the metadata-dirty*/
/* flag in Photo.  Thus, MetadataWriter should *always* be running, even if the user has turned off*/
/* the feature, so if they turn it on MetadataWriter can properly go out and update the backing*/
/* files.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define METADATA_WRITER_TYPE_COMMIT_JOB (metadata_writer_commit_job_get_type ())
#define METADATA_WRITER_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob))
#define METADATA_WRITER_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))
#define METADATA_WRITER_IS_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_IS_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_COMMIT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))

typedef struct _MetadataWriterCommitJob MetadataWriterCommitJob;
typedef struct _MetadataWriterCommitJobClass MetadataWriterCommitJobClass;
enum  {
	METADATA_WRITER_0_PROPERTY,
	METADATA_WRITER_NUM_PROPERTIES
};
static GParamSpec* metadata_writer_properties[METADATA_WRITER_NUM_PROPERTIES];
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _timed_queue_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _MetadataWriterCommitJobPrivate MetadataWriterCommitJobPrivate;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
enum  {
	METADATA_WRITER_PROGRESS_SIGNAL,
	METADATA_WRITER_NUM_SIGNALS
};
static guint metadata_writer_signals[METADATA_WRITER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MetadataWriterPrivate {
	Workers* workers;
	gboolean enabled;
	HashTimedQueue* dirty;
	GeeHashMap* pending;
	GeeHashSet* interested_photo_details;
	LibraryPhoto* ignore_photo_alteration;
	guint outstanding_total;
	guint outstanding_completed;
	gboolean closed;
	gint pause_count;
	GeeHashSet* importing_photos;
	GSettings* file_settings;
};

struct _MetadataWriterCommitJob {
	BackgroundJob parent_instance;
	MetadataWriterCommitJobPrivate * priv;
	LibraryPhoto* photo;
	GeeSet* current_keywords;
	PhotoReimportMasterState* reimport_master_state;
	PhotoReimportEditableState* reimport_editable_state;
	GError* err;
};

struct _MetadataWriterCommitJobClass {
	BackgroundJobClass parent_class;
};

static gint MetadataWriter_private_offset;
static gpointer metadata_writer_parent_class = NULL;
static MetadataWriter* metadata_writer_instance;
static MetadataWriter* metadata_writer_instance = NULL;
static gpointer metadata_writer_commit_job_parent_class = NULL;

static GType metadata_writer_commit_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void metadata_writer_on_importing_photos (MetadataWriter* self,
                                          GeeCollection* media_sources);
static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender,
                                                                                         GeeCollection* media,
                                                                                         gpointer self);
static void metadata_writer_on_photos_imported (MetadataWriter* self,
                                         GeeCollection* media_sources);
static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender,
                                                                                         GeeCollection* media,
                                                                                         gpointer self);
static void metadata_writer_on_photos_added_removed (MetadataWriter* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender,
                                                                                GeeIterable* added,
                                                                                GeeIterable* removed,
                                                                                gpointer self);
static void metadata_writer_on_photos_altered (MetadataWriter* self,
                                        GeeMap* items);
static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                       GeeMap* items,
                                                                       gpointer self);
static void metadata_writer_on_collection_frozen (MetadataWriter* self);
static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender,
                                                                   gpointer self);
static void metadata_writer_on_collection_thawed (MetadataWriter* self);
static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender,
                                                                   gpointer self);
static void metadata_writer_on_photos_destroyed (MetadataWriter* self,
                                          GeeCollection* destroyed);
static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                             GeeCollection* destroyed,
                                                                             gpointer self);
static void metadata_writer_on_tags_altered (MetadataWriter* self,
                                      GeeMap* map);
static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender,
                                                                     GeeMap* items,
                                                                     gpointer self);
static void metadata_writer_on_tag_contents_altered (MetadataWriter* self,
                                              ContainerSource* container,
                                              GeeCollection* added,
                                              gboolean relinking,
                                              GeeCollection* removed,
                                              gboolean unlinking);
static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender,
                                                                                                      ContainerSource* container,
                                                                                                      GeeCollection* added,
                                                                                                      gboolean relinked,
                                                                                                      GeeCollection* removed,
                                                                                                      gboolean unlinked,
                                                                                                      gpointer self);
static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self,
                                              ContainerSource* container,
                                              GeeCollection* sources);
static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender,
                                                                                                         ContainerSource* container,
                                                                                                         GeeCollection* sources,
                                                                                                         gpointer self);
static void metadata_writer_on_application_exiting (MetadataWriter* self);
static void _metadata_writer_on_application_exiting_photos_application_exiting (PhotosApplication* _sender,
                                                                         gboolean panicked,
                                                                         gpointer self);
static void metadata_writer_on_monitor_installed (MetadataWriter* self,
                                           LibraryMonitor* monitor);
static void _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed (LibraryMonitorPool* _sender,
                                                                                   LibraryMonitor* monitor,
                                                                                   gpointer self);
static void metadata_writer_on_monitor_destroyed (MetadataWriter* self,
                                           LibraryMonitor* monitor);
static void _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed (LibraryMonitorPool* _sender,
                                                                                   LibraryMonitor* monitor,
                                                                                   gpointer self);
static MetadataWriter* metadata_writer_new (void);
static MetadataWriter* metadata_writer_construct (GType object_type);
static void metadata_writer_on_photo_dequeued (MetadataWriter* self,
                                        LibraryPhoto* photo);
static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item,
                                                           gpointer self);
static void metadata_writer_on_config_changed (MetadataWriter* self,
                                        const gchar* key);
static void _metadata_writer_on_config_changed_g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self);
static void metadata_writer_schedule_if_dirty (MetadataWriter* self,
                                        GeeIterable* media_sources,
                                        const gchar* reason);
static void metadata_writer_cancel_all (MetadataWriter* self,
                                 gboolean wait);
static void metadata_writer_on_discovery_completed (MetadataWriter* self);
static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender,
                                                                                    gpointer self);
static gboolean metadata_writer_cancel_job (MetadataWriter* self,
                                     LibraryPhoto* photo);
static void metadata_writer_photos_are_dirty (MetadataWriter* self,
                                       GeeCollection* photos,
                                       const gchar* reason,
                                       gboolean already_marked);
static void metadata_writer_count_enqueued_work (MetadataWriter* self,
                                          gint count,
                                          gboolean report);
static void metadata_writer_count_cancelled_work (MetadataWriter* self,
                                           gint count,
                                           gboolean report);
static void metadata_writer_count_completed_work (MetadataWriter* self,
                                           gint count,
                                           gboolean report);
static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner,
                                                         LibraryPhoto* photo,
                                                         GeeSet* keywords);
static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type,
                                                               MetadataWriter* owner,
                                                               LibraryPhoto* photo,
                                                               GeeSet* keywords);
static void metadata_writer_on_update_completed (MetadataWriter* self,
                                          BackgroundJob* j);
static void metadata_writer_on_update_cancelled (MetadataWriter* self,
                                          BackgroundJob* j);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job,
                                                               gpointer self);
static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job,
                                                                 gpointer self);
static void metadata_writer_commit_job_real_execute (BackgroundJob* base);
static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self,
                                               GError** error);
static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self,
                                                 GError** error);
static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self,
                                                     PhotoMetadata* metadata,
                                                     gboolean skip_orientation);
static void metadata_writer_commit_job_finalize (BackgroundJob * obj);
static GType metadata_writer_commit_job_get_type_once (void);
static void metadata_writer_finalize (GObject * obj);
static GType metadata_writer_get_type_once (void);

static const gchar* METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS[3] = {"name", "comment", "exposure-time"};

static inline gpointer
metadata_writer_get_instance_private (MetadataWriter* self)
{
	return G_STRUCT_MEMBER_P (self, MetadataWriter_private_offset);
}

static void
_metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender,
                                                                                    GeeCollection* media,
                                                                                    gpointer self)
{
#line 221 "../src/MetadataWriter.vala"
	metadata_writer_on_importing_photos ((MetadataWriter*) self, media);
#line 267 "MetadataWriter.c"
}

static void
_metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender,
                                                                                    GeeCollection* media,
                                                                                    gpointer self)
{
#line 222 "../src/MetadataWriter.vala"
	metadata_writer_on_photos_imported ((MetadataWriter*) self, media);
#line 277 "MetadataWriter.c"
}

static void
_metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender,
                                                                           GeeIterable* added,
                                                                           GeeIterable* removed,
                                                                           gpointer self)
{
#line 223 "../src/MetadataWriter.vala"
	metadata_writer_on_photos_added_removed ((MetadataWriter*) self, added, removed);
#line 288 "MetadataWriter.c"
}

static void
_metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                  GeeMap* items,
                                                                  gpointer self)
{
#line 224 "../src/MetadataWriter.vala"
	metadata_writer_on_photos_altered ((MetadataWriter*) self, items);
#line 298 "MetadataWriter.c"
}

static void
_metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender,
                                                              gpointer self)
{
#line 225 "../src/MetadataWriter.vala"
	metadata_writer_on_collection_frozen ((MetadataWriter*) self);
#line 307 "MetadataWriter.c"
}

static void
_metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender,
                                                              gpointer self)
{
#line 226 "../src/MetadataWriter.vala"
	metadata_writer_on_collection_thawed ((MetadataWriter*) self);
#line 316 "MetadataWriter.c"
}

static void
_metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                        GeeCollection* destroyed,
                                                                        gpointer self)
{
#line 227 "../src/MetadataWriter.vala"
	metadata_writer_on_photos_destroyed ((MetadataWriter*) self, destroyed);
#line 326 "MetadataWriter.c"
}

static void
_metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender,
                                                                GeeMap* items,
                                                                gpointer self)
{
#line 229 "../src/MetadataWriter.vala"
	metadata_writer_on_tags_altered ((MetadataWriter*) self, items);
#line 336 "MetadataWriter.c"
}

static void
_metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender,
                                                                                                 ContainerSource* container,
                                                                                                 GeeCollection* added,
                                                                                                 gboolean relinked,
                                                                                                 GeeCollection* removed,
                                                                                                 gboolean unlinked,
                                                                                                 gpointer self)
{
#line 230 "../src/MetadataWriter.vala"
	metadata_writer_on_tag_contents_altered ((MetadataWriter*) self, container, added, relinked, removed, unlinked);
#line 350 "MetadataWriter.c"
}

static void
_metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender,
                                                                                                    ContainerSource* container,
                                                                                                    GeeCollection* sources,
                                                                                                    gpointer self)
{
#line 231 "../src/MetadataWriter.vala"
	metadata_writer_on_tag_backlink_removed ((MetadataWriter*) self, container, sources);
#line 361 "MetadataWriter.c"
}

static void
_metadata_writer_on_application_exiting_photos_application_exiting (PhotosApplication* _sender,
                                                                    gboolean panicked,
                                                                    gpointer self)
{
#line 235 "../src/MetadataWriter.vala"
	metadata_writer_on_application_exiting ((MetadataWriter*) self);
#line 371 "MetadataWriter.c"
}

static void
_metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed (LibraryMonitorPool* _sender,
                                                                              LibraryMonitor* monitor,
                                                                              gpointer self)
{
#line 237 "../src/MetadataWriter.vala"
	metadata_writer_on_monitor_installed ((MetadataWriter*) self, monitor);
#line 381 "MetadataWriter.c"
}

static void
_metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed (LibraryMonitorPool* _sender,
                                                                              LibraryMonitor* monitor,
                                                                              gpointer self)
{
#line 238 "../src/MetadataWriter.vala"
	metadata_writer_on_monitor_destroyed ((MetadataWriter*) self, monitor);
#line 391 "MetadataWriter.c"
}

static void
_metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item,
                                                      gpointer self)
{
#line 181 "../src/MetadataWriter.vala"
	metadata_writer_on_photo_dequeued ((MetadataWriter*) self, (LibraryPhoto*) item);
#line 400 "MetadataWriter.c"
}

static void
_metadata_writer_on_config_changed_g_settings_changed (GSettings* _sender,
                                                       const gchar* key,
                                                       gpointer self)
{
#line 195 "../src/MetadataWriter.vala"
	metadata_writer_on_config_changed ((MetadataWriter*) self, key);
#line 410 "MetadataWriter.c"
}

static MetadataWriter*
metadata_writer_construct (GType object_type)
{
	MetadataWriter * self = NULL;
	GSettings* _tmp0_;
	HashTimedQueue* _tmp1_;
	HashTimedQueue* _tmp2_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	LibraryPhotoSourceCollection* _tmp8_;
	LibraryPhotoSourceCollection* _tmp9_;
	LibraryPhotoSourceCollection* _tmp10_;
	LibraryPhotoSourceCollection* _tmp11_;
	LibraryPhotoSourceCollection* _tmp12_;
	LibraryPhotoSourceCollection* _tmp13_;
	LibraryPhotoSourceCollection* _tmp14_;
	TagSourceCollection* _tmp15_;
	TagSourceCollection* _tmp16_;
	TagSourceCollection* _tmp17_;
	TagSourceCollection* _tmp18_;
	TagSourceCollection* _tmp19_;
	GApplication* _tmp20_;
	LibraryMonitorPool* _tmp21_;
	LibraryMonitorPool* _tmp22_;
	LibraryMonitorPool* _tmp23_;
	LibraryMonitorPool* _tmp24_;
#line 179 "../src/MetadataWriter.vala"
	self = (MetadataWriter*) g_object_new (object_type, NULL);
#line 180 "../src/MetadataWriter.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME);
#line 180 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 180 "../src/MetadataWriter.vala"
	self->priv->file_settings = _tmp0_;
#line 181 "../src/MetadataWriter.vala"
	_tmp1_ = hash_timed_queue_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, METADATA_WRITER_COMMIT_DELAY_MSEC, _metadata_writer_on_photo_dequeued_dequeued_callback, self, NULL, NULL, NULL, NULL, NULL, NULL, G_PRIORITY_DEFAULT);
#line 181 "../src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 181 "../src/MetadataWriter.vala"
	self->priv->dirty = _tmp1_;
#line 182 "../src/MetadataWriter.vala"
	_tmp2_ = self->priv->dirty;
#line 182 "../src/MetadataWriter.vala"
	timed_queue_set_dequeue_spacing_msec ((TimedQueue*) _tmp2_, METADATA_WRITER_COMMIT_SPACING_MSEC);
#line 187 "../src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 459 "MetadataWriter.c"
	{
		const gchar** detail_collection = NULL;
		gint detail_collection_length1 = 0;
		gint _detail_collection_size_ = 0;
		gint detail_it = 0;
#line 190 "../src/MetadataWriter.vala"
		detail_collection = METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS;
#line 190 "../src/MetadataWriter.vala"
		detail_collection_length1 = G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS);
#line 190 "../src/MetadataWriter.vala"
		for (detail_it = 0; detail_it < detail_collection_length1; detail_it = detail_it + 1) {
#line 471 "MetadataWriter.c"
			gchar* _tmp3_;
			gchar* detail = NULL;
#line 190 "../src/MetadataWriter.vala"
			_tmp3_ = g_strdup (detail_collection[detail_it]);
#line 190 "../src/MetadataWriter.vala"
			detail = _tmp3_;
#line 478 "MetadataWriter.c"
			{
				GeeHashSet* _tmp4_;
				const gchar* _tmp5_;
#line 191 "../src/MetadataWriter.vala"
				_tmp4_ = self->priv->interested_photo_details;
#line 191 "../src/MetadataWriter.vala"
				_tmp5_ = detail;
#line 191 "../src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp5_);
#line 190 "../src/MetadataWriter.vala"
				_g_free0 (detail);
#line 490 "MetadataWriter.c"
			}
		}
	}
#line 194 "../src/MetadataWriter.vala"
	_tmp6_ = self->priv->file_settings;
#line 194 "../src/MetadataWriter.vala"
	self->priv->enabled = g_settings_get_boolean (_tmp6_, "commit-metadata");
#line 195 "../src/MetadataWriter.vala"
	_tmp7_ = self->priv->file_settings;
#line 195 "../src/MetadataWriter.vala"
	g_signal_connect_object (_tmp7_, "changed", (GCallback) _metadata_writer_on_config_changed_g_settings_changed, self, 0);
#line 198 "../src/MetadataWriter.vala"
	metadata_writer_force_rescan (self);
#line 200 "../src/MetadataWriter.vala"
	_tmp8_ = library_photo_global;
#line 200 "../src/MetadataWriter.vala"
	g_signal_connect_object ((MediaSourceCollection*) _tmp8_, "media-import-starting", (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self, 0);
#line 201 "../src/MetadataWriter.vala"
	_tmp9_ = library_photo_global;
#line 201 "../src/MetadataWriter.vala"
	g_signal_connect_object ((MediaSourceCollection*) _tmp9_, "media-import-completed", (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self, 0);
#line 202 "../src/MetadataWriter.vala"
	_tmp10_ = library_photo_global;
#line 202 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp10_, "contents-altered", (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self, 0);
#line 203 "../src/MetadataWriter.vala"
	_tmp11_ = library_photo_global;
#line 203 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp11_, "items-altered", (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self, 0);
#line 204 "../src/MetadataWriter.vala"
	_tmp12_ = library_photo_global;
#line 204 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp12_, "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 205 "../src/MetadataWriter.vala"
	_tmp13_ = library_photo_global;
#line 205 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp13_, "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 206 "../src/MetadataWriter.vala"
	_tmp14_ = library_photo_global;
#line 206 "../src/MetadataWriter.vala"
	g_signal_connect_object ((SourceCollection*) _tmp14_, "items-destroyed", (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self, 0);
#line 208 "../src/MetadataWriter.vala"
	_tmp15_ = tag_global;
#line 208 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp15_, "items-altered", (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self, 0);
#line 209 "../src/MetadataWriter.vala"
	_tmp16_ = tag_global;
#line 209 "../src/MetadataWriter.vala"
	g_signal_connect_object ((ContainerSourceCollection*) _tmp16_, "container-contents-altered", (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self, 0);
#line 210 "../src/MetadataWriter.vala"
	_tmp17_ = tag_global;
#line 210 "../src/MetadataWriter.vala"
	g_signal_connect_object ((ContainerSourceCollection*) _tmp17_, "backlink-to-container-removed", (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self, 0);
#line 211 "../src/MetadataWriter.vala"
	_tmp18_ = tag_global;
#line 211 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp18_, "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 212 "../src/MetadataWriter.vala"
	_tmp19_ = tag_global;
#line 212 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DataCollection*) _tmp19_, "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 214 "../src/MetadataWriter.vala"
	_tmp20_ = g_application_get_default ();
#line 214 "../src/MetadataWriter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, PHOTOS_TYPE_APPLICATION, PhotosApplication), "exiting", (GCallback) _metadata_writer_on_application_exiting_photos_application_exiting, self, 0);
#line 216 "../src/MetadataWriter.vala"
	_tmp21_ = library_monitor_pool_get_instance ();
#line 216 "../src/MetadataWriter.vala"
	_tmp22_ = _tmp21_;
#line 216 "../src/MetadataWriter.vala"
	g_signal_connect_object (_tmp22_, "monitor-installed", (GCallback) _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed, self, 0);
#line 216 "../src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp22_);
#line 217 "../src/MetadataWriter.vala"
	_tmp23_ = library_monitor_pool_get_instance ();
#line 217 "../src/MetadataWriter.vala"
	_tmp24_ = _tmp23_;
#line 217 "../src/MetadataWriter.vala"
	g_signal_connect_object (_tmp24_, "monitor-destroyed", (GCallback) _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed, self, 0);
#line 217 "../src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp24_);
#line 179 "../src/MetadataWriter.vala"
	return self;
#line 574 "MetadataWriter.c"
}

static MetadataWriter*
metadata_writer_new (void)
{
#line 179 "../src/MetadataWriter.vala"
	return metadata_writer_construct (TYPE_METADATA_WRITER);
#line 582 "MetadataWriter.c"
}

void
metadata_writer_init (void)
{
	MetadataWriter* _tmp0_;
#line 242 "../src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_new ();
#line 242 "../src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 242 "../src/MetadataWriter.vala"
	metadata_writer_instance = _tmp0_;
#line 595 "MetadataWriter.c"
}

void
metadata_writer_terminate (void)
{
	MetadataWriter* _tmp0_;
#line 246 "../src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 246 "../src/MetadataWriter.vala"
	if (_tmp0_ != NULL) {
#line 606 "MetadataWriter.c"
		MetadataWriter* _tmp1_;
#line 247 "../src/MetadataWriter.vala"
		_tmp1_ = metadata_writer_instance;
#line 247 "../src/MetadataWriter.vala"
		metadata_writer_close (_tmp1_);
#line 612 "MetadataWriter.c"
	}
#line 249 "../src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 249 "../src/MetadataWriter.vala"
	metadata_writer_instance = NULL;
#line 618 "MetadataWriter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 253 "../src/MetadataWriter.vala"
	return self ? g_object_ref (self) : NULL;
#line 626 "MetadataWriter.c"
}

MetadataWriter*
metadata_writer_get_instance (void)
{
	MetadataWriter* _tmp0_;
	MetadataWriter* _tmp1_;
	MetadataWriter* result;
#line 253 "../src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 253 "../src/MetadataWriter.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 253 "../src/MetadataWriter.vala"
	result = _tmp1_;
#line 253 "../src/MetadataWriter.vala"
	return result;
#line 643 "MetadataWriter.c"
}

void
metadata_writer_force_rescan (MetadataWriter* self)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
#line 257 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/MetadataWriter.vala"
	_tmp0_ = library_photo_global;
#line 258 "../src/MetadataWriter.vala"
	_tmp1_ = data_collection_get_all ((DataCollection*) _tmp0_);
#line 258 "../src/MetadataWriter.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 258 "../src/MetadataWriter.vala"
	metadata_writer_schedule_if_dirty (self, (GeeIterable*) _tmp2_, "force rescan");
#line 258 "../src/MetadataWriter.vala"
	_g_object_unref0 (_tmp2_);
#line 664 "MetadataWriter.c"
}

void
metadata_writer_pause (MetadataWriter* self)
{
	gint _tmp0_;
	HashTimedQueue* _tmp1_;
#line 261 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/MetadataWriter.vala"
	_tmp0_ = self->priv->pause_count;
#line 262 "../src/MetadataWriter.vala"
	self->priv->pause_count = _tmp0_ + 1;
#line 262 "../src/MetadataWriter.vala"
	if (_tmp0_ != 0) {
#line 263 "../src/MetadataWriter.vala"
		return;
#line 682 "MetadataWriter.c"
	}
#line 265 "../src/MetadataWriter.vala"
	_tmp1_ = self->priv->dirty;
#line 265 "../src/MetadataWriter.vala"
	timed_queue_pause ((TimedQueue*) _tmp1_);
#line 267 "../src/MetadataWriter.vala"
	g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, (guint) 0, (guint) 0);
#line 690 "MetadataWriter.c"
}

void
metadata_writer_unpause (MetadataWriter* self)
{
	gboolean _tmp0_ = FALSE;
	HashTimedQueue* _tmp2_;
#line 270 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/MetadataWriter.vala"
	if (self->priv->pause_count == 0) {
#line 271 "../src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 704 "MetadataWriter.c"
	} else {
		gint _tmp1_;
#line 271 "../src/MetadataWriter.vala"
		self->priv->pause_count = self->priv->pause_count - 1;
#line 271 "../src/MetadataWriter.vala"
		_tmp1_ = self->priv->pause_count;
#line 271 "../src/MetadataWriter.vala"
		_tmp0_ = _tmp1_ != 0;
#line 713 "MetadataWriter.c"
	}
#line 271 "../src/MetadataWriter.vala"
	if (_tmp0_) {
#line 272 "../src/MetadataWriter.vala"
		return;
#line 719 "MetadataWriter.c"
	}
#line 274 "../src/MetadataWriter.vala"
	_tmp2_ = self->priv->dirty;
#line 274 "../src/MetadataWriter.vala"
	timed_queue_unpause ((TimedQueue*) _tmp2_);
#line 725 "MetadataWriter.c"
}

void
metadata_writer_close (MetadataWriter* self)
{
#line 277 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/MetadataWriter.vala"
	if (self->priv->closed) {
#line 279 "../src/MetadataWriter.vala"
		return;
#line 737 "MetadataWriter.c"
	}
#line 281 "../src/MetadataWriter.vala"
	metadata_writer_cancel_all (self, TRUE);
#line 283 "../src/MetadataWriter.vala"
	self->priv->closed = TRUE;
#line 743 "MetadataWriter.c"
}

static void
metadata_writer_on_config_changed (MetadataWriter* self,
                                   const gchar* key)
{
	gboolean value = FALSE;
	GSettings* _tmp0_;
#line 286 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/MetadataWriter.vala"
	g_return_if_fail (key != NULL);
#line 287 "../src/MetadataWriter.vala"
	if (g_strcmp0 (key, "commit-metadata") != 0) {
#line 288 "../src/MetadataWriter.vala"
		return;
#line 760 "MetadataWriter.c"
	}
#line 291 "../src/MetadataWriter.vala"
	_tmp0_ = self->priv->file_settings;
#line 291 "../src/MetadataWriter.vala"
	value = g_settings_get_boolean (_tmp0_, "commit-metadata");
#line 293 "../src/MetadataWriter.vala"
	if (self->priv->enabled == value) {
#line 294 "../src/MetadataWriter.vala"
		return;
#line 770 "MetadataWriter.c"
	}
#line 296 "../src/MetadataWriter.vala"
	self->priv->enabled = value;
#line 297 "../src/MetadataWriter.vala"
	if (self->priv->enabled) {
#line 298 "../src/MetadataWriter.vala"
		metadata_writer_force_rescan (self);
#line 778 "MetadataWriter.c"
	} else {
#line 300 "../src/MetadataWriter.vala"
		metadata_writer_cancel_all (self, FALSE);
#line 782 "MetadataWriter.c"
	}
}

static void
metadata_writer_on_application_exiting (MetadataWriter* self)
{
#line 303 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/MetadataWriter.vala"
	metadata_writer_close (self);
#line 793 "MetadataWriter.c"
}

static void
_metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender,
                                                                               gpointer self)
{
#line 308 "../src/MetadataWriter.vala"
	metadata_writer_on_discovery_completed ((MetadataWriter*) self);
#line 802 "MetadataWriter.c"
}

static void
metadata_writer_on_monitor_installed (MetadataWriter* self,
                                      LibraryMonitor* monitor)
{
#line 307 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/MetadataWriter.vala"
	g_return_if_fail (monitor != NULL);
#line 308 "../src/MetadataWriter.vala"
	g_signal_connect_object ((DirectoryMonitor*) monitor, "discovery-completed", (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self, 0);
#line 815 "MetadataWriter.c"
}

static void
metadata_writer_on_monitor_destroyed (MetadataWriter* self,
                                      LibraryMonitor* monitor)
{
	guint _tmp0_;
#line 311 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/MetadataWriter.vala"
	g_return_if_fail (monitor != NULL);
#line 312 "../src/MetadataWriter.vala"
	g_signal_parse_name ("discovery-completed", TYPE_DIRECTORY_MONITOR, &_tmp0_, NULL, FALSE);
#line 312 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DirectoryMonitor*) monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self);
#line 831 "MetadataWriter.c"
}

static void
metadata_writer_on_discovery_completed (MetadataWriter* self)
{
#line 315 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 841 "MetadataWriter.c"
}

static void
metadata_writer_on_collection_frozen (MetadataWriter* self)
{
#line 319 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 320 "../src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 851 "MetadataWriter.c"
}

static void
metadata_writer_on_collection_thawed (MetadataWriter* self)
{
#line 323 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 861 "MetadataWriter.c"
}

static void
metadata_writer_on_importing_photos (MetadataWriter* self,
                                     GeeCollection* media_sources)
{
	GeeHashSet* _tmp0_;
#line 327 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/MetadataWriter.vala"
	g_return_if_fail (media_sources != NULL);
#line 328 "../src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 328 "../src/MetadataWriter.vala"
	gee_collection_add_all ((GeeCollection*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_COLLECTION, GeeCollection));
#line 877 "MetadataWriter.c"
}

static void
metadata_writer_on_photos_imported (MetadataWriter* self,
                                    GeeCollection* media_sources)
{
	GeeHashSet* _tmp0_;
#line 331 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 331 "../src/MetadataWriter.vala"
	g_return_if_fail (media_sources != NULL);
#line 332 "../src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 332 "../src/MetadataWriter.vala"
	gee_collection_remove_all ((GeeCollection*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_COLLECTION, GeeCollection));
#line 893 "MetadataWriter.c"
}

static void
metadata_writer_on_photos_added_removed (MetadataWriter* self,
                                         GeeIterable* added,
                                         GeeIterable* removed)
{
	gboolean _tmp0_ = FALSE;
#line 335 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 338 "../src/MetadataWriter.vala"
	if (added != NULL) {
#line 338 "../src/MetadataWriter.vala"
		_tmp0_ = self->priv->enabled;
#line 908 "MetadataWriter.c"
	} else {
#line 338 "../src/MetadataWriter.vala"
		_tmp0_ = FALSE;
#line 912 "MetadataWriter.c"
	}
#line 338 "../src/MetadataWriter.vala"
	if (_tmp0_) {
#line 339 "../src/MetadataWriter.vala"
		metadata_writer_schedule_if_dirty (self, G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_ITERABLE, GeeIterable), "added to LibraryPhoto.global");
#line 918 "MetadataWriter.c"
	}
#line 342 "../src/MetadataWriter.vala"
	if (removed != NULL) {
#line 922 "MetadataWriter.c"
		gboolean cancelled = FALSE;
#line 343 "../src/MetadataWriter.vala"
		cancelled = FALSE;
#line 926 "MetadataWriter.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp1_;
#line 344 "../src/MetadataWriter.vala"
			_tmp1_ = gee_iterable_iterator (removed);
#line 344 "../src/MetadataWriter.vala"
			_object_it = _tmp1_;
#line 344 "../src/MetadataWriter.vala"
			while (TRUE) {
#line 936 "MetadataWriter.c"
				GeeIterator* _tmp2_;
				DataObject* object = NULL;
				GeeIterator* _tmp3_;
				gpointer _tmp4_;
				gboolean _tmp5_ = FALSE;
				DataObject* _tmp6_;
#line 344 "../src/MetadataWriter.vala"
				_tmp2_ = _object_it;
#line 344 "../src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp2_)) {
#line 344 "../src/MetadataWriter.vala"
					break;
#line 949 "MetadataWriter.c"
				}
#line 344 "../src/MetadataWriter.vala"
				_tmp3_ = _object_it;
#line 344 "../src/MetadataWriter.vala"
				_tmp4_ = gee_iterator_get (_tmp3_);
#line 344 "../src/MetadataWriter.vala"
				object = (DataObject*) _tmp4_;
#line 345 "../src/MetadataWriter.vala"
				_tmp6_ = object;
#line 345 "../src/MetadataWriter.vala"
				if (metadata_writer_cancel_job (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO, LibraryPhoto))) {
#line 345 "../src/MetadataWriter.vala"
					_tmp5_ = TRUE;
#line 963 "MetadataWriter.c"
				} else {
#line 345 "../src/MetadataWriter.vala"
					_tmp5_ = cancelled;
#line 967 "MetadataWriter.c"
				}
#line 345 "../src/MetadataWriter.vala"
				cancelled = _tmp5_;
#line 344 "../src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 973 "MetadataWriter.c"
			}
#line 344 "../src/MetadataWriter.vala"
			_g_object_unref0 (_object_it);
#line 977 "MetadataWriter.c"
		}
#line 347 "../src/MetadataWriter.vala"
		if (cancelled) {
#line 348 "../src/MetadataWriter.vala"
			g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, self->priv->outstanding_completed, self->priv->outstanding_total);
#line 983 "MetadataWriter.c"
		}
	}
}

static void
metadata_writer_on_photos_altered (MetadataWriter* self,
                                   GeeMap* items)
{
	GeeHashSet* photos = NULL;
	GeeHashSet* _tmp33_;
#line 352 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/MetadataWriter.vala"
	g_return_if_fail (items != NULL);
#line 353 "../src/MetadataWriter.vala"
	photos = NULL;
#line 1000 "MetadataWriter.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 354 "../src/MetadataWriter.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 354 "../src/MetadataWriter.vala"
		_tmp1_ = _tmp0_;
#line 354 "../src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 354 "../src/MetadataWriter.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 354 "../src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 354 "../src/MetadataWriter.vala"
		_g_object_unref0 (_tmp2_);
#line 354 "../src/MetadataWriter.vala"
		_object_it = _tmp4_;
#line 354 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 1024 "MetadataWriter.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp8_;
			LibraryPhoto* _tmp9_;
			LibraryPhoto* _tmp10_;
			LibraryPhoto* _tmp11_;
			Alteration* alteration = NULL;
			DataObject* _tmp12_;
			gpointer _tmp13_;
			Alteration* _tmp14_;
			GeeCollection* details = NULL;
			Alteration* _tmp19_;
			GeeCollection* _tmp20_;
			GeeCollection* _tmp21_;
#line 354 "../src/MetadataWriter.vala"
			_tmp5_ = _object_it;
#line 354 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 354 "../src/MetadataWriter.vala"
				break;
#line 1048 "MetadataWriter.c"
			}
#line 354 "../src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 354 "../src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 354 "../src/MetadataWriter.vala"
			object = (DataObject*) _tmp7_;
#line 355 "../src/MetadataWriter.vala"
			_tmp8_ = object;
#line 355 "../src/MetadataWriter.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 355 "../src/MetadataWriter.vala"
			photo = _tmp9_;
#line 359 "../src/MetadataWriter.vala"
			_tmp10_ = photo;
#line 359 "../src/MetadataWriter.vala"
			_tmp11_ = self->priv->ignore_photo_alteration;
#line 359 "../src/MetadataWriter.vala"
			if (_tmp10_ == _tmp11_) {
#line 360 "../src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 360 "../src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 360 "../src/MetadataWriter.vala"
				continue;
#line 1074 "MetadataWriter.c"
			}
#line 362 "../src/MetadataWriter.vala"
			_tmp12_ = object;
#line 362 "../src/MetadataWriter.vala"
			_tmp13_ = gee_map_get (items, _tmp12_);
#line 362 "../src/MetadataWriter.vala"
			alteration = (Alteration*) _tmp13_;
#line 365 "../src/MetadataWriter.vala"
			_tmp14_ = alteration;
#line 365 "../src/MetadataWriter.vala"
			if (alteration_has_detail (_tmp14_, "image", "orientation")) {
#line 1086 "MetadataWriter.c"
				GeeHashSet* _tmp15_;
				GeeHashSet* _tmp17_;
				LibraryPhoto* _tmp18_;
#line 366 "../src/MetadataWriter.vala"
				_tmp15_ = photos;
#line 366 "../src/MetadataWriter.vala"
				if (_tmp15_ == NULL) {
#line 1094 "MetadataWriter.c"
					GeeHashSet* _tmp16_;
#line 367 "../src/MetadataWriter.vala"
					_tmp16_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 367 "../src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 367 "../src/MetadataWriter.vala"
					photos = _tmp16_;
#line 1102 "MetadataWriter.c"
				}
#line 369 "../src/MetadataWriter.vala"
				_tmp17_ = photos;
#line 369 "../src/MetadataWriter.vala"
				_tmp18_ = photo;
#line 369 "../src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 371 "../src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 371 "../src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 371 "../src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 371 "../src/MetadataWriter.vala"
				continue;
#line 1118 "MetadataWriter.c"
			}
#line 375 "../src/MetadataWriter.vala"
			_tmp19_ = alteration;
#line 375 "../src/MetadataWriter.vala"
			_tmp20_ = alteration_get_details (_tmp19_, "metadata");
#line 375 "../src/MetadataWriter.vala"
			details = _tmp20_;
#line 376 "../src/MetadataWriter.vala"
			_tmp21_ = details;
#line 376 "../src/MetadataWriter.vala"
			if (_tmp21_ == NULL) {
#line 377 "../src/MetadataWriter.vala"
				_g_object_unref0 (details);
#line 377 "../src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 377 "../src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 377 "../src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 377 "../src/MetadataWriter.vala"
				continue;
#line 1140 "MetadataWriter.c"
			}
			{
				GeeIterator* _detail_it = NULL;
				GeeCollection* _tmp22_;
				GeeIterator* _tmp23_;
#line 380 "../src/MetadataWriter.vala"
				_tmp22_ = details;
#line 380 "../src/MetadataWriter.vala"
				_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 380 "../src/MetadataWriter.vala"
				_detail_it = _tmp23_;
#line 380 "../src/MetadataWriter.vala"
				while (TRUE) {
#line 1154 "MetadataWriter.c"
					GeeIterator* _tmp24_;
					gchar* detail = NULL;
					GeeIterator* _tmp25_;
					gpointer _tmp26_;
					GeeHashSet* _tmp27_;
					const gchar* _tmp28_;
#line 380 "../src/MetadataWriter.vala"
					_tmp24_ = _detail_it;
#line 380 "../src/MetadataWriter.vala"
					if (!gee_iterator_next (_tmp24_)) {
#line 380 "../src/MetadataWriter.vala"
						break;
#line 1167 "MetadataWriter.c"
					}
#line 380 "../src/MetadataWriter.vala"
					_tmp25_ = _detail_it;
#line 380 "../src/MetadataWriter.vala"
					_tmp26_ = gee_iterator_get (_tmp25_);
#line 380 "../src/MetadataWriter.vala"
					detail = (gchar*) _tmp26_;
#line 381 "../src/MetadataWriter.vala"
					_tmp27_ = self->priv->interested_photo_details;
#line 381 "../src/MetadataWriter.vala"
					_tmp28_ = detail;
#line 381 "../src/MetadataWriter.vala"
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp27_, _tmp28_)) {
#line 1181 "MetadataWriter.c"
						GeeHashSet* _tmp29_;
						GeeHashSet* _tmp31_;
						LibraryPhoto* _tmp32_;
#line 382 "../src/MetadataWriter.vala"
						_tmp29_ = photos;
#line 382 "../src/MetadataWriter.vala"
						if (_tmp29_ == NULL) {
#line 1189 "MetadataWriter.c"
							GeeHashSet* _tmp30_;
#line 383 "../src/MetadataWriter.vala"
							_tmp30_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 383 "../src/MetadataWriter.vala"
							_g_object_unref0 (photos);
#line 383 "../src/MetadataWriter.vala"
							photos = _tmp30_;
#line 1197 "MetadataWriter.c"
						}
#line 385 "../src/MetadataWriter.vala"
						_tmp31_ = photos;
#line 385 "../src/MetadataWriter.vala"
						_tmp32_ = photo;
#line 385 "../src/MetadataWriter.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp32_);
#line 387 "../src/MetadataWriter.vala"
						_g_free0 (detail);
#line 387 "../src/MetadataWriter.vala"
						break;
#line 1209 "MetadataWriter.c"
					}
#line 380 "../src/MetadataWriter.vala"
					_g_free0 (detail);
#line 1213 "MetadataWriter.c"
				}
#line 380 "../src/MetadataWriter.vala"
				_g_object_unref0 (_detail_it);
#line 1217 "MetadataWriter.c"
			}
#line 354 "../src/MetadataWriter.vala"
			_g_object_unref0 (details);
#line 354 "../src/MetadataWriter.vala"
			_alteration_unref0 (alteration);
#line 354 "../src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 354 "../src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 1227 "MetadataWriter.c"
		}
#line 354 "../src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 1231 "MetadataWriter.c"
	}
#line 392 "../src/MetadataWriter.vala"
	_tmp33_ = photos;
#line 392 "../src/MetadataWriter.vala"
	if (_tmp33_ != NULL) {
#line 1237 "MetadataWriter.c"
		GeeHashSet* _tmp34_;
#line 393 "../src/MetadataWriter.vala"
		_tmp34_ = photos;
#line 393 "../src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp34_, "alteration", FALSE);
#line 1243 "MetadataWriter.c"
	}
#line 352 "../src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 1247 "MetadataWriter.c"
}

static void
metadata_writer_on_photos_destroyed (MetadataWriter* self,
                                     GeeCollection* destroyed)
{
#line 396 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 396 "../src/MetadataWriter.vala"
	g_return_if_fail (destroyed != NULL);
#line 1258 "MetadataWriter.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 397 "../src/MetadataWriter.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) destroyed);
#line 397 "../src/MetadataWriter.vala"
		_source_it = _tmp0_;
#line 397 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 1268 "MetadataWriter.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp4_;
			LibraryPhoto* _tmp5_;
			LibraryPhoto* _tmp6_;
			GeeHashSet* _tmp7_;
			LibraryPhoto* _tmp8_;
#line 397 "../src/MetadataWriter.vala"
			_tmp1_ = _source_it;
#line 397 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 397 "../src/MetadataWriter.vala"
				break;
#line 1285 "MetadataWriter.c"
			}
#line 397 "../src/MetadataWriter.vala"
			_tmp2_ = _source_it;
#line 397 "../src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 397 "../src/MetadataWriter.vala"
			source = (DataSource*) _tmp3_;
#line 398 "../src/MetadataWriter.vala"
			_tmp4_ = source;
#line 398 "../src/MetadataWriter.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 398 "../src/MetadataWriter.vala"
			photo = _tmp5_;
#line 399 "../src/MetadataWriter.vala"
			_tmp6_ = photo;
#line 399 "../src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp6_);
#line 400 "../src/MetadataWriter.vala"
			_tmp7_ = self->priv->importing_photos;
#line 400 "../src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 400 "../src/MetadataWriter.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 397 "../src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 397 "../src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 1313 "MetadataWriter.c"
		}
#line 397 "../src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 1317 "MetadataWriter.c"
	}
}

static void
metadata_writer_on_tags_altered (MetadataWriter* self,
                                 GeeMap* map)
{
	GeeHashSet* photos = NULL;
	GeeHashSet* _tmp27_;
#line 404 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/MetadataWriter.vala"
	g_return_if_fail (map != NULL);
#line 405 "../src/MetadataWriter.vala"
	photos = NULL;
#line 1333 "MetadataWriter.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 406 "../src/MetadataWriter.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 406 "../src/MetadataWriter.vala"
		_tmp1_ = _tmp0_;
#line 406 "../src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 406 "../src/MetadataWriter.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 406 "../src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 406 "../src/MetadataWriter.vala"
		_g_object_unref0 (_tmp2_);
#line 406 "../src/MetadataWriter.vala"
		_object_it = _tmp4_;
#line 406 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 1357 "MetadataWriter.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			Alteration* _tmp10_;
			gboolean _tmp11_;
			GeeHashSet* _tmp12_;
#line 406 "../src/MetadataWriter.vala"
			_tmp5_ = _object_it;
#line 406 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 406 "../src/MetadataWriter.vala"
				break;
#line 1373 "MetadataWriter.c"
			}
#line 406 "../src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 406 "../src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 406 "../src/MetadataWriter.vala"
			object = (DataObject*) _tmp7_;
#line 407 "../src/MetadataWriter.vala"
			_tmp8_ = object;
#line 407 "../src/MetadataWriter.vala"
			_tmp9_ = gee_map_get (map, _tmp8_);
#line 407 "../src/MetadataWriter.vala"
			_tmp10_ = (Alteration*) _tmp9_;
#line 407 "../src/MetadataWriter.vala"
			_tmp11_ = !alteration_has_detail (_tmp10_, "metadata", "name");
#line 407 "../src/MetadataWriter.vala"
			_alteration_unref0 (_tmp10_);
#line 407 "../src/MetadataWriter.vala"
			if (_tmp11_) {
#line 408 "../src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 408 "../src/MetadataWriter.vala"
				continue;
#line 1397 "MetadataWriter.c"
			}
#line 410 "../src/MetadataWriter.vala"
			_tmp12_ = photos;
#line 410 "../src/MetadataWriter.vala"
			if (_tmp12_ == NULL) {
#line 1403 "MetadataWriter.c"
				GeeHashSet* _tmp13_;
#line 411 "../src/MetadataWriter.vala"
				_tmp13_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 411 "../src/MetadataWriter.vala"
				_g_object_unref0 (photos);
#line 411 "../src/MetadataWriter.vala"
				photos = _tmp13_;
#line 1411 "MetadataWriter.c"
			}
			{
				GeeIterator* _media_it = NULL;
				DataObject* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				GeeIterator* _tmp17_;
				GeeIterator* _tmp18_;
#line 413 "../src/MetadataWriter.vala"
				_tmp14_ = object;
#line 413 "../src/MetadataWriter.vala"
				_tmp15_ = tag_get_sources (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_TAG, Tag));
#line 413 "../src/MetadataWriter.vala"
				_tmp16_ = _tmp15_;
#line 413 "../src/MetadataWriter.vala"
				_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 413 "../src/MetadataWriter.vala"
				_tmp18_ = _tmp17_;
#line 413 "../src/MetadataWriter.vala"
				_g_object_unref0 (_tmp16_);
#line 413 "../src/MetadataWriter.vala"
				_media_it = _tmp18_;
#line 413 "../src/MetadataWriter.vala"
				while (TRUE) {
#line 1436 "MetadataWriter.c"
					GeeIterator* _tmp19_;
					MediaSource* media = NULL;
					GeeIterator* _tmp20_;
					gpointer _tmp21_;
					LibraryPhoto* photo = NULL;
					MediaSource* _tmp22_;
					LibraryPhoto* _tmp23_;
					LibraryPhoto* _tmp24_;
#line 413 "../src/MetadataWriter.vala"
					_tmp19_ = _media_it;
#line 413 "../src/MetadataWriter.vala"
					if (!gee_iterator_next (_tmp19_)) {
#line 413 "../src/MetadataWriter.vala"
						break;
#line 1451 "MetadataWriter.c"
					}
#line 413 "../src/MetadataWriter.vala"
					_tmp20_ = _media_it;
#line 413 "../src/MetadataWriter.vala"
					_tmp21_ = gee_iterator_get (_tmp20_);
#line 413 "../src/MetadataWriter.vala"
					media = (MediaSource*) _tmp21_;
#line 414 "../src/MetadataWriter.vala"
					_tmp22_ = media;
#line 414 "../src/MetadataWriter.vala"
					_tmp23_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp22_) ? ((LibraryPhoto*) _tmp22_) : NULL);
#line 414 "../src/MetadataWriter.vala"
					photo = _tmp23_;
#line 415 "../src/MetadataWriter.vala"
					_tmp24_ = photo;
#line 415 "../src/MetadataWriter.vala"
					if (_tmp24_ != NULL) {
#line 1469 "MetadataWriter.c"
						GeeHashSet* _tmp25_;
						LibraryPhoto* _tmp26_;
#line 416 "../src/MetadataWriter.vala"
						_tmp25_ = photos;
#line 416 "../src/MetadataWriter.vala"
						_tmp26_ = photo;
#line 416 "../src/MetadataWriter.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 1478 "MetadataWriter.c"
					}
#line 413 "../src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 413 "../src/MetadataWriter.vala"
					_g_object_unref0 (media);
#line 1484 "MetadataWriter.c"
				}
#line 413 "../src/MetadataWriter.vala"
				_g_object_unref0 (_media_it);
#line 1488 "MetadataWriter.c"
			}
#line 406 "../src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 1492 "MetadataWriter.c"
		}
#line 406 "../src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 1496 "MetadataWriter.c"
	}
#line 420 "../src/MetadataWriter.vala"
	_tmp27_ = photos;
#line 420 "../src/MetadataWriter.vala"
	if (_tmp27_ != NULL) {
#line 1502 "MetadataWriter.c"
		GeeHashSet* _tmp28_;
#line 421 "../src/MetadataWriter.vala"
		_tmp28_ = photos;
#line 421 "../src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp28_, "tag renamed", FALSE);
#line 1508 "MetadataWriter.c"
	}
#line 404 "../src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 1512 "MetadataWriter.c"
}

static void
metadata_writer_on_tag_contents_altered (MetadataWriter* self,
                                         ContainerSource* container,
                                         GeeCollection* added,
                                         gboolean relinking,
                                         GeeCollection* removed,
                                         gboolean unlinking)
{
	Tag* tag = NULL;
	Tag* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp21_ = FALSE;
#line 424 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 424 "../src/MetadataWriter.vala"
	g_return_if_fail (container != NULL);
#line 426 "../src/MetadataWriter.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (container, TYPE_TAG, Tag));
#line 426 "../src/MetadataWriter.vala"
	tag = _tmp0_;
#line 428 "../src/MetadataWriter.vala"
	if (added != NULL) {
#line 428 "../src/MetadataWriter.vala"
		_tmp1_ = !relinking;
#line 1539 "MetadataWriter.c"
	} else {
#line 428 "../src/MetadataWriter.vala"
		_tmp1_ = FALSE;
#line 1543 "MetadataWriter.c"
	}
#line 428 "../src/MetadataWriter.vala"
	if (_tmp1_) {
#line 1547 "MetadataWriter.c"
		GeeArrayList* added_photos = NULL;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp15_;
		Tag* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 429 "../src/MetadataWriter.vala"
		_tmp2_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 429 "../src/MetadataWriter.vala"
		added_photos = _tmp2_;
#line 1560 "MetadataWriter.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp3_;
#line 430 "../src/MetadataWriter.vala"
			_tmp3_ = gee_iterable_iterator ((GeeIterable*) added);
#line 430 "../src/MetadataWriter.vala"
			_source_it = _tmp3_;
#line 430 "../src/MetadataWriter.vala"
			while (TRUE) {
#line 1570 "MetadataWriter.c"
				GeeIterator* _tmp4_;
				DataSource* source = NULL;
				GeeIterator* _tmp5_;
				gpointer _tmp6_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp7_;
				LibraryPhoto* _tmp8_;
				gboolean _tmp9_ = FALSE;
				LibraryPhoto* _tmp10_;
#line 430 "../src/MetadataWriter.vala"
				_tmp4_ = _source_it;
#line 430 "../src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp4_)) {
#line 430 "../src/MetadataWriter.vala"
					break;
#line 1586 "MetadataWriter.c"
				}
#line 430 "../src/MetadataWriter.vala"
				_tmp5_ = _source_it;
#line 430 "../src/MetadataWriter.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 430 "../src/MetadataWriter.vala"
				source = (DataSource*) _tmp6_;
#line 431 "../src/MetadataWriter.vala"
				_tmp7_ = source;
#line 431 "../src/MetadataWriter.vala"
				_tmp8_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp7_) ? ((LibraryPhoto*) _tmp7_) : NULL);
#line 431 "../src/MetadataWriter.vala"
				photo = _tmp8_;
#line 432 "../src/MetadataWriter.vala"
				_tmp10_ = photo;
#line 432 "../src/MetadataWriter.vala"
				if (_tmp10_ != NULL) {
#line 1604 "MetadataWriter.c"
					GeeHashSet* _tmp11_;
					LibraryPhoto* _tmp12_;
#line 432 "../src/MetadataWriter.vala"
					_tmp11_ = self->priv->importing_photos;
#line 432 "../src/MetadataWriter.vala"
					_tmp12_ = photo;
#line 432 "../src/MetadataWriter.vala"
					_tmp9_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 1613 "MetadataWriter.c"
				} else {
#line 432 "../src/MetadataWriter.vala"
					_tmp9_ = FALSE;
#line 1617 "MetadataWriter.c"
				}
#line 432 "../src/MetadataWriter.vala"
				if (_tmp9_) {
#line 1621 "MetadataWriter.c"
					GeeArrayList* _tmp13_;
					LibraryPhoto* _tmp14_;
#line 433 "../src/MetadataWriter.vala"
					_tmp13_ = added_photos;
#line 433 "../src/MetadataWriter.vala"
					_tmp14_ = photo;
#line 433 "../src/MetadataWriter.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 1630 "MetadataWriter.c"
				}
#line 430 "../src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 430 "../src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 1636 "MetadataWriter.c"
			}
#line 430 "../src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 1640 "MetadataWriter.c"
		}
#line 436 "../src/MetadataWriter.vala"
		_tmp15_ = added_photos;
#line 436 "../src/MetadataWriter.vala"
		_tmp16_ = tag;
#line 436 "../src/MetadataWriter.vala"
		_tmp17_ = data_object_to_string ((DataObject*) _tmp16_);
#line 436 "../src/MetadataWriter.vala"
		_tmp18_ = _tmp17_;
#line 436 "../src/MetadataWriter.vala"
		_tmp19_ = g_strdup_printf ("added to %s", _tmp18_);
#line 436 "../src/MetadataWriter.vala"
		_tmp20_ = _tmp19_;
#line 436 "../src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp15_, _tmp20_, FALSE);
#line 436 "../src/MetadataWriter.vala"
		_g_free0 (_tmp20_);
#line 436 "../src/MetadataWriter.vala"
		_g_free0 (_tmp18_);
#line 428 "../src/MetadataWriter.vala"
		_g_object_unref0 (added_photos);
#line 1662 "MetadataWriter.c"
	}
#line 439 "../src/MetadataWriter.vala"
	if (removed != NULL) {
#line 439 "../src/MetadataWriter.vala"
		_tmp21_ = !unlinking;
#line 1668 "MetadataWriter.c"
	} else {
#line 439 "../src/MetadataWriter.vala"
		_tmp21_ = FALSE;
#line 1672 "MetadataWriter.c"
	}
#line 439 "../src/MetadataWriter.vala"
	if (_tmp21_) {
#line 1676 "MetadataWriter.c"
		GeeArrayList* removed_photos = NULL;
		GeeArrayList* _tmp22_;
		GeeArrayList* _tmp32_;
		Tag* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 440 "../src/MetadataWriter.vala"
		_tmp22_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 440 "../src/MetadataWriter.vala"
		removed_photos = _tmp22_;
#line 1689 "MetadataWriter.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp23_;
#line 441 "../src/MetadataWriter.vala"
			_tmp23_ = gee_iterable_iterator ((GeeIterable*) removed);
#line 441 "../src/MetadataWriter.vala"
			_source_it = _tmp23_;
#line 441 "../src/MetadataWriter.vala"
			while (TRUE) {
#line 1699 "MetadataWriter.c"
				GeeIterator* _tmp24_;
				DataSource* source = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp27_;
				LibraryPhoto* _tmp28_;
				LibraryPhoto* _tmp29_;
#line 441 "../src/MetadataWriter.vala"
				_tmp24_ = _source_it;
#line 441 "../src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 441 "../src/MetadataWriter.vala"
					break;
#line 1714 "MetadataWriter.c"
				}
#line 441 "../src/MetadataWriter.vala"
				_tmp25_ = _source_it;
#line 441 "../src/MetadataWriter.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 441 "../src/MetadataWriter.vala"
				source = (DataSource*) _tmp26_;
#line 442 "../src/MetadataWriter.vala"
				_tmp27_ = source;
#line 442 "../src/MetadataWriter.vala"
				_tmp28_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp27_) ? ((LibraryPhoto*) _tmp27_) : NULL);
#line 442 "../src/MetadataWriter.vala"
				photo = _tmp28_;
#line 443 "../src/MetadataWriter.vala"
				_tmp29_ = photo;
#line 443 "../src/MetadataWriter.vala"
				if (_tmp29_ != NULL) {
#line 1732 "MetadataWriter.c"
					GeeArrayList* _tmp30_;
					LibraryPhoto* _tmp31_;
#line 444 "../src/MetadataWriter.vala"
					_tmp30_ = removed_photos;
#line 444 "../src/MetadataWriter.vala"
					_tmp31_ = photo;
#line 444 "../src/MetadataWriter.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 1741 "MetadataWriter.c"
				}
#line 441 "../src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 441 "../src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 1747 "MetadataWriter.c"
			}
#line 441 "../src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 1751 "MetadataWriter.c"
		}
#line 447 "../src/MetadataWriter.vala"
		_tmp32_ = removed_photos;
#line 447 "../src/MetadataWriter.vala"
		_tmp33_ = tag;
#line 447 "../src/MetadataWriter.vala"
		_tmp34_ = data_object_to_string ((DataObject*) _tmp33_);
#line 447 "../src/MetadataWriter.vala"
		_tmp35_ = _tmp34_;
#line 447 "../src/MetadataWriter.vala"
		_tmp36_ = g_strdup_printf ("removed from %s", _tmp35_);
#line 447 "../src/MetadataWriter.vala"
		_tmp37_ = _tmp36_;
#line 447 "../src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp32_, _tmp37_, FALSE);
#line 447 "../src/MetadataWriter.vala"
		_g_free0 (_tmp37_);
#line 447 "../src/MetadataWriter.vala"
		_g_free0 (_tmp35_);
#line 439 "../src/MetadataWriter.vala"
		_g_object_unref0 (removed_photos);
#line 1773 "MetadataWriter.c"
	}
#line 424 "../src/MetadataWriter.vala"
	_g_object_unref0 (tag);
#line 1777 "MetadataWriter.c"
}

static void
metadata_writer_on_tag_backlink_removed (MetadataWriter* self,
                                         ContainerSource* container,
                                         GeeCollection* sources)
{
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
#line 451 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 451 "../src/MetadataWriter.vala"
	g_return_if_fail (container != NULL);
#line 451 "../src/MetadataWriter.vala"
	g_return_if_fail (sources != NULL);
#line 452 "../src/MetadataWriter.vala"
	_tmp0_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 452 "../src/MetadataWriter.vala"
	photos = _tmp0_;
#line 1802 "MetadataWriter.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp1_;
#line 453 "../src/MetadataWriter.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) sources);
#line 453 "../src/MetadataWriter.vala"
		_source_it = _tmp1_;
#line 453 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 1812 "MetadataWriter.c"
			GeeIterator* _tmp2_;
			DataSource* source = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			LibraryPhoto* _tmp7_;
#line 453 "../src/MetadataWriter.vala"
			_tmp2_ = _source_it;
#line 453 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 453 "../src/MetadataWriter.vala"
				break;
#line 1827 "MetadataWriter.c"
			}
#line 453 "../src/MetadataWriter.vala"
			_tmp3_ = _source_it;
#line 453 "../src/MetadataWriter.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 453 "../src/MetadataWriter.vala"
			source = (DataSource*) _tmp4_;
#line 454 "../src/MetadataWriter.vala"
			_tmp5_ = source;
#line 454 "../src/MetadataWriter.vala"
			_tmp6_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp5_) ? ((LibraryPhoto*) _tmp5_) : NULL);
#line 454 "../src/MetadataWriter.vala"
			photo = _tmp6_;
#line 455 "../src/MetadataWriter.vala"
			_tmp7_ = photo;
#line 455 "../src/MetadataWriter.vala"
			if (_tmp7_ != NULL) {
#line 1845 "MetadataWriter.c"
				GeeArrayList* _tmp8_;
				LibraryPhoto* _tmp9_;
#line 456 "../src/MetadataWriter.vala"
				_tmp8_ = photos;
#line 456 "../src/MetadataWriter.vala"
				_tmp9_ = photo;
#line 456 "../src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 1854 "MetadataWriter.c"
			}
#line 453 "../src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 453 "../src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 1860 "MetadataWriter.c"
		}
#line 453 "../src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 1864 "MetadataWriter.c"
	}
#line 459 "../src/MetadataWriter.vala"
	_tmp10_ = photos;
#line 459 "../src/MetadataWriter.vala"
	_tmp11_ = data_object_to_string ((DataObject*) container);
#line 459 "../src/MetadataWriter.vala"
	_tmp12_ = _tmp11_;
#line 459 "../src/MetadataWriter.vala"
	_tmp13_ = g_strdup_printf ("backlink removed from %s", _tmp12_);
#line 459 "../src/MetadataWriter.vala"
	_tmp14_ = _tmp13_;
#line 459 "../src/MetadataWriter.vala"
	metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp10_, _tmp14_, FALSE);
#line 459 "../src/MetadataWriter.vala"
	_g_free0 (_tmp14_);
#line 459 "../src/MetadataWriter.vala"
	_g_free0 (_tmp12_);
#line 451 "../src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 1884 "MetadataWriter.c"
}

static void
metadata_writer_count_enqueued_work (MetadataWriter* self,
                                     gint count,
                                     gboolean report)
{
#line 462 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/MetadataWriter.vala"
	self->priv->outstanding_total = self->priv->outstanding_total + count;
#line 469 "../src/MetadataWriter.vala"
	if (report) {
#line 470 "../src/MetadataWriter.vala"
		g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, self->priv->outstanding_completed, self->priv->outstanding_total);
#line 1900 "MetadataWriter.c"
	}
}

static void
metadata_writer_count_cancelled_work (MetadataWriter* self,
                                      gint count,
                                      gboolean report)
{
	guint _tmp0_ = 0U;
#line 473 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/MetadataWriter.vala"
	if (self->priv->outstanding_total >= ((guint) count)) {
#line 474 "../src/MetadataWriter.vala"
		_tmp0_ = self->priv->outstanding_total - count;
#line 1916 "MetadataWriter.c"
	} else {
#line 474 "../src/MetadataWriter.vala"
		_tmp0_ = (guint) 0;
#line 1920 "MetadataWriter.c"
	}
#line 474 "../src/MetadataWriter.vala"
	self->priv->outstanding_total = _tmp0_;
#line 475 "../src/MetadataWriter.vala"
	if (self->priv->outstanding_completed >= self->priv->outstanding_total) {
#line 476 "../src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 477 "../src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 1930 "MetadataWriter.c"
	}
#line 484 "../src/MetadataWriter.vala"
	if (report) {
#line 485 "../src/MetadataWriter.vala"
		g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, self->priv->outstanding_completed, self->priv->outstanding_total);
#line 1936 "MetadataWriter.c"
	}
}

static void
metadata_writer_count_completed_work (MetadataWriter* self,
                                      gint count,
                                      gboolean report)
{
#line 488 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 489 "../src/MetadataWriter.vala"
	self->priv->outstanding_completed = self->priv->outstanding_completed + count;
#line 490 "../src/MetadataWriter.vala"
	if (self->priv->outstanding_completed >= self->priv->outstanding_total) {
#line 491 "../src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 492 "../src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 1955 "MetadataWriter.c"
	}
#line 499 "../src/MetadataWriter.vala"
	if (report) {
#line 500 "../src/MetadataWriter.vala"
		g_signal_emit (self, metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL], 0, self->priv->outstanding_completed, self->priv->outstanding_total);
#line 1961 "MetadataWriter.c"
	}
}

static void
metadata_writer_schedule_if_dirty (MetadataWriter* self,
                                   GeeIterable* media_sources,
                                   const gchar* reason)
{
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp14_;
#line 503 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 503 "../src/MetadataWriter.vala"
	g_return_if_fail (media_sources != NULL);
#line 503 "../src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 504 "../src/MetadataWriter.vala"
	photos = NULL;
#line 1980 "MetadataWriter.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp0_;
#line 505 "../src/MetadataWriter.vala"
		_tmp0_ = gee_iterable_iterator (media_sources);
#line 505 "../src/MetadataWriter.vala"
		_media_it = _tmp0_;
#line 505 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 1990 "MetadataWriter.c"
			GeeIterator* _tmp1_;
			MediaSource* media = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp4_;
			LibraryPhoto* _tmp5_;
			LibraryPhoto* _tmp6_;
			GeeHashSet* _tmp7_;
			LibraryPhoto* _tmp8_;
			LibraryPhoto* _tmp9_;
#line 505 "../src/MetadataWriter.vala"
			_tmp1_ = _media_it;
#line 505 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 505 "../src/MetadataWriter.vala"
				break;
#line 2008 "MetadataWriter.c"
			}
#line 505 "../src/MetadataWriter.vala"
			_tmp2_ = _media_it;
#line 505 "../src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 505 "../src/MetadataWriter.vala"
			media = (MediaSource*) _tmp3_;
#line 506 "../src/MetadataWriter.vala"
			_tmp4_ = media;
#line 506 "../src/MetadataWriter.vala"
			_tmp5_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp4_) ? ((LibraryPhoto*) _tmp4_) : NULL);
#line 506 "../src/MetadataWriter.vala"
			photo = _tmp5_;
#line 507 "../src/MetadataWriter.vala"
			_tmp6_ = photo;
#line 507 "../src/MetadataWriter.vala"
			if (_tmp6_ == NULL) {
#line 508 "../src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 508 "../src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 508 "../src/MetadataWriter.vala"
				continue;
#line 2032 "MetadataWriter.c"
			}
#line 511 "../src/MetadataWriter.vala"
			_tmp7_ = self->priv->importing_photos;
#line 511 "../src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 511 "../src/MetadataWriter.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp7_, _tmp8_)) {
#line 512 "../src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 512 "../src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 512 "../src/MetadataWriter.vala"
				continue;
#line 2046 "MetadataWriter.c"
			}
#line 514 "../src/MetadataWriter.vala"
			_tmp9_ = photo;
#line 514 "../src/MetadataWriter.vala"
			if (photo_is_master_metadata_dirty ((Photo*) _tmp9_)) {
#line 2052 "MetadataWriter.c"
				GeeArrayList* _tmp10_;
				GeeArrayList* _tmp12_;
				LibraryPhoto* _tmp13_;
#line 515 "../src/MetadataWriter.vala"
				_tmp10_ = photos;
#line 515 "../src/MetadataWriter.vala"
				if (_tmp10_ == NULL) {
#line 2060 "MetadataWriter.c"
					GeeArrayList* _tmp11_;
#line 516 "../src/MetadataWriter.vala"
					_tmp11_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 516 "../src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 516 "../src/MetadataWriter.vala"
					photos = _tmp11_;
#line 2068 "MetadataWriter.c"
				}
#line 518 "../src/MetadataWriter.vala"
				_tmp12_ = photos;
#line 518 "../src/MetadataWriter.vala"
				_tmp13_ = photo;
#line 518 "../src/MetadataWriter.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 2076 "MetadataWriter.c"
			}
#line 505 "../src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 505 "../src/MetadataWriter.vala"
			_g_object_unref0 (media);
#line 2082 "MetadataWriter.c"
		}
#line 505 "../src/MetadataWriter.vala"
		_g_object_unref0 (_media_it);
#line 2086 "MetadataWriter.c"
	}
#line 522 "../src/MetadataWriter.vala"
	_tmp14_ = photos;
#line 522 "../src/MetadataWriter.vala"
	if (_tmp14_ != NULL) {
#line 2092 "MetadataWriter.c"
		GeeArrayList* _tmp15_;
#line 523 "../src/MetadataWriter.vala"
		_tmp15_ = photos;
#line 523 "../src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, (GeeCollection*) _tmp15_, reason, TRUE);
#line 2098 "MetadataWriter.c"
	}
#line 503 "../src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2102 "MetadataWriter.c"
}

static void
metadata_writer_photos_are_dirty (MetadataWriter* self,
                                  GeeCollection* photos,
                                  const gchar* reason,
                                  gboolean already_marked)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp22_ = FALSE;
	gint _tmp29_;
	gint _tmp30_;
	GError* _inner_error0_ = NULL;
#line 527 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 527 "../src/MetadataWriter.vala"
	g_return_if_fail (photos != NULL);
#line 527 "../src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 528 "../src/MetadataWriter.vala"
	_tmp0_ = gee_collection_get_size (photos);
#line 528 "../src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 528 "../src/MetadataWriter.vala"
	if (_tmp1_ == 0) {
#line 529 "../src/MetadataWriter.vala"
		return;
#line 2131 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it = NULL;
		GeeIterator* _tmp2_;
#line 532 "../src/MetadataWriter.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) photos);
#line 532 "../src/MetadataWriter.vala"
		_photo_it = _tmp2_;
#line 532 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 2142 "MetadataWriter.c"
			GeeIterator* _tmp3_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			LibraryPhoto* _tmp6_;
#line 532 "../src/MetadataWriter.vala"
			_tmp3_ = _photo_it;
#line 532 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 532 "../src/MetadataWriter.vala"
				break;
#line 2154 "MetadataWriter.c"
			}
#line 532 "../src/MetadataWriter.vala"
			_tmp4_ = _photo_it;
#line 532 "../src/MetadataWriter.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 532 "../src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp5_;
#line 533 "../src/MetadataWriter.vala"
			_tmp6_ = photo;
#line 533 "../src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp6_);
#line 532 "../src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 2168 "MetadataWriter.c"
		}
#line 532 "../src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 2172 "MetadataWriter.c"
	}
#line 536 "../src/MetadataWriter.vala"
	if (!already_marked) {
#line 2176 "MetadataWriter.c"
		{
			LibraryPhotoSourceCollection* _tmp7_;
			TransactionController* _tmp8_;
			TransactionController* _tmp9_;
			LibraryPhotoSourceCollection* _tmp15_;
			TransactionController* _tmp16_;
			TransactionController* _tmp17_;
#line 538 "../src/MetadataWriter.vala"
			_tmp7_ = library_photo_global;
#line 538 "../src/MetadataWriter.vala"
			_tmp8_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp7_);
#line 538 "../src/MetadataWriter.vala"
			_tmp9_ = _tmp8_;
#line 538 "../src/MetadataWriter.vala"
			transaction_controller_begin (_tmp9_);
#line 2192 "MetadataWriter.c"
			{
				GeeIterator* _photo_it = NULL;
				GeeIterator* _tmp10_;
#line 540 "../src/MetadataWriter.vala"
				_tmp10_ = gee_iterable_iterator ((GeeIterable*) photos);
#line 540 "../src/MetadataWriter.vala"
				_photo_it = _tmp10_;
#line 540 "../src/MetadataWriter.vala"
				while (TRUE) {
#line 2202 "MetadataWriter.c"
					GeeIterator* _tmp11_;
					LibraryPhoto* photo = NULL;
					GeeIterator* _tmp12_;
					gpointer _tmp13_;
					LibraryPhoto* _tmp14_;
#line 540 "../src/MetadataWriter.vala"
					_tmp11_ = _photo_it;
#line 540 "../src/MetadataWriter.vala"
					if (!gee_iterator_next (_tmp11_)) {
#line 540 "../src/MetadataWriter.vala"
						break;
#line 2214 "MetadataWriter.c"
					}
#line 540 "../src/MetadataWriter.vala"
					_tmp12_ = _photo_it;
#line 540 "../src/MetadataWriter.vala"
					_tmp13_ = gee_iterator_get (_tmp12_);
#line 540 "../src/MetadataWriter.vala"
					photo = (LibraryPhoto*) _tmp13_;
#line 541 "../src/MetadataWriter.vala"
					_tmp14_ = photo;
#line 541 "../src/MetadataWriter.vala"
					photo_set_master_metadata_dirty ((Photo*) _tmp14_, TRUE, &_inner_error0_);
#line 541 "../src/MetadataWriter.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 541 "../src/MetadataWriter.vala"
						_g_object_unref0 (photo);
#line 541 "../src/MetadataWriter.vala"
						_g_object_unref0 (_photo_it);
#line 2232 "MetadataWriter.c"
						goto __catch0_g_error;
					}
#line 540 "../src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 2237 "MetadataWriter.c"
				}
#line 540 "../src/MetadataWriter.vala"
				_g_object_unref0 (_photo_it);
#line 2241 "MetadataWriter.c"
			}
#line 543 "../src/MetadataWriter.vala"
			_tmp15_ = library_photo_global;
#line 543 "../src/MetadataWriter.vala"
			_tmp16_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp15_);
#line 543 "../src/MetadataWriter.vala"
			_tmp17_ = _tmp16_;
#line 543 "../src/MetadataWriter.vala"
			transaction_controller_commit (_tmp17_);
#line 2251 "MetadataWriter.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp18_;
#line 537 "../src/MetadataWriter.vala"
			err = _inner_error0_;
#line 537 "../src/MetadataWriter.vala"
			_inner_error0_ = NULL;
#line 545 "../src/MetadataWriter.vala"
			_tmp18_ = err;
#line 545 "../src/MetadataWriter.vala"
			if (_tmp18_->domain == DATABASE_ERROR) {
#line 2266 "MetadataWriter.c"
				GError* _tmp19_;
#line 546 "../src/MetadataWriter.vala"
				_tmp19_ = err;
#line 546 "../src/MetadataWriter.vala"
				app_window_database_error ((GError*) _tmp19_);
#line 2272 "MetadataWriter.c"
			} else {
				GError* _tmp20_;
				const gchar* _tmp21_;
#line 548 "../src/MetadataWriter.vala"
				_tmp20_ = err;
#line 548 "../src/MetadataWriter.vala"
				_tmp21_ = _tmp20_->message;
#line 548 "../src/MetadataWriter.vala"
				g_error ("MetadataWriter.vala:548: Unable to mark metadata as dirty: %s", _tmp21_);
#line 2282 "MetadataWriter.c"
			}
#line 537 "../src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 2286 "MetadataWriter.c"
		}
		__finally0:
#line 537 "../src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 537 "../src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 537 "../src/MetadataWriter.vala"
			g_clear_error (&_inner_error0_);
#line 537 "../src/MetadataWriter.vala"
			return;
#line 2297 "MetadataWriter.c"
		}
	}
#line 554 "../src/MetadataWriter.vala"
	if (self->priv->closed) {
#line 554 "../src/MetadataWriter.vala"
		_tmp22_ = TRUE;
#line 2304 "MetadataWriter.c"
	} else {
#line 554 "../src/MetadataWriter.vala"
		_tmp22_ = !self->priv->enabled;
#line 2308 "MetadataWriter.c"
	}
#line 554 "../src/MetadataWriter.vala"
	if (_tmp22_) {
#line 555 "../src/MetadataWriter.vala"
		return;
#line 2314 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it = NULL;
		GeeIterator* _tmp23_;
#line 561 "../src/MetadataWriter.vala"
		_tmp23_ = gee_iterable_iterator ((GeeIterable*) photos);
#line 561 "../src/MetadataWriter.vala"
		_photo_it = _tmp23_;
#line 561 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 2325 "MetadataWriter.c"
			GeeIterator* _tmp24_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			gboolean enqueued = FALSE;
			HashTimedQueue* _tmp27_;
			LibraryPhoto* _tmp28_;
#line 561 "../src/MetadataWriter.vala"
			_tmp24_ = _photo_it;
#line 561 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp24_)) {
#line 561 "../src/MetadataWriter.vala"
				break;
#line 2339 "MetadataWriter.c"
			}
#line 561 "../src/MetadataWriter.vala"
			_tmp25_ = _photo_it;
#line 561 "../src/MetadataWriter.vala"
			_tmp26_ = gee_iterator_get (_tmp25_);
#line 561 "../src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp26_;
#line 562 "../src/MetadataWriter.vala"
			_tmp27_ = self->priv->dirty;
#line 562 "../src/MetadataWriter.vala"
			_tmp28_ = photo;
#line 562 "../src/MetadataWriter.vala"
			enqueued = timed_queue_enqueue ((TimedQueue*) _tmp27_, _tmp28_);
#line 563 "../src/MetadataWriter.vala"
			_vala_assert (enqueued, "enqueued");
#line 561 "../src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 2357 "MetadataWriter.c"
		}
#line 561 "../src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 2361 "MetadataWriter.c"
	}
#line 566 "../src/MetadataWriter.vala"
	_tmp29_ = gee_collection_get_size (photos);
#line 566 "../src/MetadataWriter.vala"
	_tmp30_ = _tmp29_;
#line 566 "../src/MetadataWriter.vala"
	metadata_writer_count_enqueued_work (self, _tmp30_, TRUE);
#line 2369 "MetadataWriter.c"
}

static void
metadata_writer_cancel_all (MetadataWriter* self,
                            gboolean wait)
{
	HashTimedQueue* _tmp0_;
#line 569 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 570 "../src/MetadataWriter.vala"
	_tmp0_ = self->priv->dirty;
#line 570 "../src/MetadataWriter.vala"
	timed_queue_clear ((TimedQueue*) _tmp0_);
#line 2383 "MetadataWriter.c"
	{
		GeeIterator* _job_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 572 "../src/MetadataWriter.vala"
		_tmp1_ = self->priv->pending;
#line 572 "../src/MetadataWriter.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 572 "../src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 572 "../src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 572 "../src/MetadataWriter.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 572 "../src/MetadataWriter.vala"
		_tmp6_ = _tmp5_;
#line 572 "../src/MetadataWriter.vala"
		_g_object_unref0 (_tmp4_);
#line 572 "../src/MetadataWriter.vala"
		_job_it = _tmp6_;
#line 572 "../src/MetadataWriter.vala"
		while (TRUE) {
#line 2410 "MetadataWriter.c"
			GeeIterator* _tmp7_;
			MetadataWriterCommitJob* job = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			MetadataWriterCommitJob* _tmp10_;
#line 572 "../src/MetadataWriter.vala"
			_tmp7_ = _job_it;
#line 572 "../src/MetadataWriter.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 572 "../src/MetadataWriter.vala"
				break;
#line 2422 "MetadataWriter.c"
			}
#line 572 "../src/MetadataWriter.vala"
			_tmp8_ = _job_it;
#line 572 "../src/MetadataWriter.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 572 "../src/MetadataWriter.vala"
			job = (MetadataWriterCommitJob*) _tmp9_;
#line 573 "../src/MetadataWriter.vala"
			_tmp10_ = job;
#line 573 "../src/MetadataWriter.vala"
			background_job_cancel ((BackgroundJob*) _tmp10_);
#line 572 "../src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 2436 "MetadataWriter.c"
		}
#line 572 "../src/MetadataWriter.vala"
		_g_object_unref0 (_job_it);
#line 2440 "MetadataWriter.c"
	}
#line 575 "../src/MetadataWriter.vala"
	if (wait) {
#line 2444 "MetadataWriter.c"
		Workers* _tmp11_;
#line 576 "../src/MetadataWriter.vala"
		_tmp11_ = self->priv->workers;
#line 576 "../src/MetadataWriter.vala"
		workers_wait_for_empty_queue (_tmp11_);
#line 2450 "MetadataWriter.c"
	}
#line 578 "../src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, G_MAXINT, TRUE);
#line 2454 "MetadataWriter.c"
}

static gboolean
metadata_writer_cancel_job (MetadataWriter* self,
                            LibraryPhoto* photo)
{
	gboolean cancelled = FALSE;
	GeeHashMap* _tmp0_;
	HashTimedQueue* _tmp4_;
	gboolean result;
#line 581 "../src/MetadataWriter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 581 "../src/MetadataWriter.vala"
	g_return_val_if_fail (photo != NULL, FALSE);
#line 582 "../src/MetadataWriter.vala"
	cancelled = FALSE;
#line 584 "../src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 584 "../src/MetadataWriter.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, photo)) {
#line 2475 "MetadataWriter.c"
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
		MetadataWriterCommitJob* _tmp3_;
#line 585 "../src/MetadataWriter.vala"
		_tmp1_ = self->priv->pending;
#line 585 "../src/MetadataWriter.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, photo);
#line 585 "../src/MetadataWriter.vala"
		_tmp3_ = (MetadataWriterCommitJob*) _tmp2_;
#line 585 "../src/MetadataWriter.vala"
		background_job_cancel ((BackgroundJob*) _tmp3_);
#line 585 "../src/MetadataWriter.vala"
		_background_job_unref0 (_tmp3_);
#line 586 "../src/MetadataWriter.vala"
		cancelled = TRUE;
#line 2491 "MetadataWriter.c"
	}
#line 589 "../src/MetadataWriter.vala"
	_tmp4_ = self->priv->dirty;
#line 589 "../src/MetadataWriter.vala"
	if (timed_queue_contains ((TimedQueue*) _tmp4_, photo)) {
#line 2497 "MetadataWriter.c"
		gboolean removed = FALSE;
		HashTimedQueue* _tmp5_;
		HashTimedQueue* _tmp6_;
#line 590 "../src/MetadataWriter.vala"
		_tmp5_ = self->priv->dirty;
#line 590 "../src/MetadataWriter.vala"
		removed = timed_queue_remove_first ((TimedQueue*) _tmp5_, photo);
#line 591 "../src/MetadataWriter.vala"
		_vala_assert (removed, "removed");
#line 593 "../src/MetadataWriter.vala"
		_tmp6_ = self->priv->dirty;
#line 593 "../src/MetadataWriter.vala"
		_vala_assert (!timed_queue_contains ((TimedQueue*) _tmp6_, photo), "!dirty.contains (photo)");
#line 595 "../src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, FALSE);
#line 596 "../src/MetadataWriter.vala"
		cancelled = TRUE;
#line 2515 "MetadataWriter.c"
	}
#line 599 "../src/MetadataWriter.vala"
	result = cancelled;
#line 599 "../src/MetadataWriter.vala"
	return result;
#line 2521 "MetadataWriter.c"
}

static void
metadata_writer_on_photo_dequeued (MetadataWriter* self,
                                   LibraryPhoto* photo)
{
	GeeSet* keywords = NULL;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeCollection* _tmp2_;
	MetadataWriterCommitJob* job = NULL;
	GeeSet* _tmp13_;
	MetadataWriterCommitJob* _tmp14_;
	GeeHashMap* _tmp15_;
	MetadataWriterCommitJob* _tmp16_;
	Workers* _tmp17_;
	MetadataWriterCommitJob* _tmp18_;
#line 602 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 602 "../src/MetadataWriter.vala"
	g_return_if_fail (photo != NULL);
#line 603 "../src/MetadataWriter.vala"
	if (!self->priv->enabled) {
#line 604 "../src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 606 "../src/MetadataWriter.vala"
		return;
#line 2550 "MetadataWriter.c"
	}
#line 609 "../src/MetadataWriter.vala"
	keywords = NULL;
#line 610 "../src/MetadataWriter.vala"
	_tmp0_ = tag_global;
#line 610 "../src/MetadataWriter.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) photo);
#line 610 "../src/MetadataWriter.vala"
	tags = (GeeCollection*) _tmp1_;
#line 611 "../src/MetadataWriter.vala"
	_tmp2_ = tags;
#line 611 "../src/MetadataWriter.vala"
	if (_tmp2_ != NULL) {
#line 2564 "MetadataWriter.c"
		GeeHashSet* _tmp3_;
#line 612 "../src/MetadataWriter.vala"
		_tmp3_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 612 "../src/MetadataWriter.vala"
		_g_object_unref0 (keywords);
#line 612 "../src/MetadataWriter.vala"
		keywords = (GeeSet*) _tmp3_;
#line 2572 "MetadataWriter.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp4_;
			GeeIterator* _tmp5_;
#line 613 "../src/MetadataWriter.vala"
			_tmp4_ = tags;
#line 613 "../src/MetadataWriter.vala"
			_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 613 "../src/MetadataWriter.vala"
			_tag_it = _tmp5_;
#line 613 "../src/MetadataWriter.vala"
			while (TRUE) {
#line 2585 "MetadataWriter.c"
				GeeIterator* _tmp6_;
				Tag* tag = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				GeeSet* _tmp9_;
				Tag* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 613 "../src/MetadataWriter.vala"
				_tmp6_ = _tag_it;
#line 613 "../src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 613 "../src/MetadataWriter.vala"
					break;
#line 2600 "MetadataWriter.c"
				}
#line 613 "../src/MetadataWriter.vala"
				_tmp7_ = _tag_it;
#line 613 "../src/MetadataWriter.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 613 "../src/MetadataWriter.vala"
				tag = (Tag*) _tmp8_;
#line 614 "../src/MetadataWriter.vala"
				_tmp9_ = keywords;
#line 614 "../src/MetadataWriter.vala"
				_tmp10_ = tag;
#line 614 "../src/MetadataWriter.vala"
				_tmp11_ = data_object_get_name ((DataObject*) _tmp10_);
#line 614 "../src/MetadataWriter.vala"
				_tmp12_ = _tmp11_;
#line 614 "../src/MetadataWriter.vala"
				gee_collection_add ((GeeCollection*) _tmp9_, _tmp12_);
#line 614 "../src/MetadataWriter.vala"
				_g_free0 (_tmp12_);
#line 613 "../src/MetadataWriter.vala"
				_g_object_unref0 (tag);
#line 2622 "MetadataWriter.c"
			}
#line 613 "../src/MetadataWriter.vala"
			_g_object_unref0 (_tag_it);
#line 2626 "MetadataWriter.c"
		}
	}
#line 617 "../src/MetadataWriter.vala"
	_tmp13_ = keywords;
#line 617 "../src/MetadataWriter.vala"
	_tmp14_ = metadata_writer_commit_job_new (self, photo, _tmp13_);
#line 617 "../src/MetadataWriter.vala"
	job = _tmp14_;
#line 618 "../src/MetadataWriter.vala"
	_tmp15_ = self->priv->pending;
#line 618 "../src/MetadataWriter.vala"
	_tmp16_ = job;
#line 618 "../src/MetadataWriter.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, photo, _tmp16_);
#line 624 "../src/MetadataWriter.vala"
	_tmp17_ = self->priv->workers;
#line 624 "../src/MetadataWriter.vala"
	_tmp18_ = job;
#line 624 "../src/MetadataWriter.vala"
	workers_enqueue (_tmp17_, (BackgroundJob*) _tmp18_);
#line 602 "../src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 602 "../src/MetadataWriter.vala"
	_g_object_unref0 (tags);
#line 602 "../src/MetadataWriter.vala"
	_g_object_unref0 (keywords);
#line 2653 "MetadataWriter.c"
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 628 "../src/MetadataWriter.vala"
	return self ? background_job_ref (self) : NULL;
#line 2661 "MetadataWriter.c"
}

static void
metadata_writer_on_update_completed (MetadataWriter* self,
                                     BackgroundJob* j)
{
	MetadataWriterCommitJob* job = NULL;
	MetadataWriterCommitJob* _tmp0_;
	MetadataWriterCommitJob* _tmp1_;
	GError* _tmp2_;
	gboolean removed = FALSE;
	GeeHashMap* _tmp14_;
	MetadataWriterCommitJob* _tmp15_;
	LibraryPhoto* _tmp16_;
	LibraryPhotoSourceCollection* _tmp17_;
	TransactionController* _tmp18_;
	TransactionController* _tmp19_;
	gboolean _tmp20_ = FALSE;
	MetadataWriterCommitJob* _tmp21_;
	PhotoReimportMasterState* _tmp22_;
	LibraryPhotoSourceCollection* _tmp48_;
	TransactionController* _tmp49_;
	TransactionController* _tmp50_;
	GError* _inner_error0_ = NULL;
#line 627 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/MetadataWriter.vala"
	g_return_if_fail (j != NULL);
#line 628 "../src/MetadataWriter.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob));
#line 628 "../src/MetadataWriter.vala"
	job = _tmp0_;
#line 630 "../src/MetadataWriter.vala"
	_tmp1_ = job;
#line 630 "../src/MetadataWriter.vala"
	_tmp2_ = _tmp1_->err;
#line 630 "../src/MetadataWriter.vala"
	if (_tmp2_ != NULL) {
#line 2700 "MetadataWriter.c"
		MetadataWriterCommitJob* _tmp3_;
		LibraryPhoto* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		MetadataWriterCommitJob* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 631 "../src/MetadataWriter.vala"
		_tmp3_ = job;
#line 631 "../src/MetadataWriter.vala"
		_tmp4_ = _tmp3_->photo;
#line 631 "../src/MetadataWriter.vala"
		_tmp5_ = data_object_to_string ((DataObject*) _tmp4_);
#line 631 "../src/MetadataWriter.vala"
		_tmp6_ = _tmp5_;
#line 631 "../src/MetadataWriter.vala"
		_tmp7_ = job;
#line 631 "../src/MetadataWriter.vala"
		_tmp8_ = _tmp7_->err;
#line 631 "../src/MetadataWriter.vala"
		_tmp9_ = _tmp8_->message;
#line 631 "../src/MetadataWriter.vala"
		g_warning ("MetadataWriter.vala:631: Unable to update metadata for %s: %s", _tmp6_, _tmp9_);
#line 631 "../src/MetadataWriter.vala"
		_g_free0 (_tmp6_);
#line 2726 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp10_;
		LibraryPhoto* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 633 "../src/MetadataWriter.vala"
		_tmp10_ = job;
#line 633 "../src/MetadataWriter.vala"
		_tmp11_ = _tmp10_->photo;
#line 633 "../src/MetadataWriter.vala"
		_tmp12_ = data_object_to_string ((DataObject*) _tmp11_);
#line 633 "../src/MetadataWriter.vala"
		_tmp13_ = _tmp12_;
#line 633 "../src/MetadataWriter.vala"
		g_message ("MetadataWriter.vala:633: Completed writing metadata for %s", _tmp13_);
#line 633 "../src/MetadataWriter.vala"
		_g_free0 (_tmp13_);
#line 2744 "MetadataWriter.c"
	}
#line 635 "../src/MetadataWriter.vala"
	_tmp14_ = self->priv->pending;
#line 635 "../src/MetadataWriter.vala"
	_tmp15_ = job;
#line 635 "../src/MetadataWriter.vala"
	_tmp16_ = _tmp15_->photo;
#line 635 "../src/MetadataWriter.vala"
	removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp14_, _tmp16_, NULL);
#line 636 "../src/MetadataWriter.vala"
	_vala_assert (removed, "removed");
#line 640 "../src/MetadataWriter.vala"
	_tmp17_ = library_photo_global;
#line 640 "../src/MetadataWriter.vala"
	_tmp18_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp17_);
#line 640 "../src/MetadataWriter.vala"
	_tmp19_ = _tmp18_;
#line 640 "../src/MetadataWriter.vala"
	transaction_controller_begin (_tmp19_);
#line 642 "../src/MetadataWriter.vala"
	_tmp21_ = job;
#line 642 "../src/MetadataWriter.vala"
	_tmp22_ = _tmp21_->reimport_master_state;
#line 642 "../src/MetadataWriter.vala"
	if (_tmp22_ != NULL) {
#line 642 "../src/MetadataWriter.vala"
		_tmp20_ = TRUE;
#line 2772 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp23_;
		PhotoReimportEditableState* _tmp24_;
#line 642 "../src/MetadataWriter.vala"
		_tmp23_ = job;
#line 642 "../src/MetadataWriter.vala"
		_tmp24_ = _tmp23_->reimport_editable_state;
#line 642 "../src/MetadataWriter.vala"
		_tmp20_ = _tmp24_ != NULL;
#line 2782 "MetadataWriter.c"
	}
#line 642 "../src/MetadataWriter.vala"
	if (_tmp20_) {
#line 2786 "MetadataWriter.c"
		LibraryPhoto* _tmp25_;
		MetadataWriterCommitJob* _tmp26_;
		LibraryPhoto* _tmp27_;
		LibraryPhoto* _tmp28_;
#line 645 "../src/MetadataWriter.vala"
		_tmp25_ = self->priv->ignore_photo_alteration;
#line 645 "../src/MetadataWriter.vala"
		_vala_assert (_tmp25_ == NULL, "ignore_photo_alteration == null");
#line 646 "../src/MetadataWriter.vala"
		_tmp26_ = job;
#line 646 "../src/MetadataWriter.vala"
		_tmp27_ = _tmp26_->photo;
#line 646 "../src/MetadataWriter.vala"
		_tmp28_ = _g_object_ref0 (_tmp27_);
#line 646 "../src/MetadataWriter.vala"
		_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 646 "../src/MetadataWriter.vala"
		self->priv->ignore_photo_alteration = _tmp28_;
#line 2805 "MetadataWriter.c"
		{
			MetadataWriterCommitJob* _tmp29_;
			PhotoReimportMasterState* _tmp30_;
			MetadataWriterCommitJob* _tmp35_;
			PhotoReimportEditableState* _tmp36_;
#line 648 "../src/MetadataWriter.vala"
			_tmp29_ = job;
#line 648 "../src/MetadataWriter.vala"
			_tmp30_ = _tmp29_->reimport_master_state;
#line 648 "../src/MetadataWriter.vala"
			if (_tmp30_ != NULL) {
#line 2817 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp31_;
				LibraryPhoto* _tmp32_;
				MetadataWriterCommitJob* _tmp33_;
				PhotoReimportMasterState* _tmp34_;
#line 649 "../src/MetadataWriter.vala"
				_tmp31_ = job;
#line 649 "../src/MetadataWriter.vala"
				_tmp32_ = _tmp31_->photo;
#line 649 "../src/MetadataWriter.vala"
				_tmp33_ = job;
#line 649 "../src/MetadataWriter.vala"
				_tmp34_ = _tmp33_->reimport_master_state;
#line 649 "../src/MetadataWriter.vala"
				photo_finish_update_master_metadata ((Photo*) _tmp32_, _tmp34_, &_inner_error0_);
#line 649 "../src/MetadataWriter.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 649 "../src/MetadataWriter.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2836 "MetadataWriter.c"
						goto __catch0_database_error;
					}
#line 649 "../src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 649 "../src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 649 "../src/MetadataWriter.vala"
					g_clear_error (&_inner_error0_);
#line 649 "../src/MetadataWriter.vala"
					return;
#line 2847 "MetadataWriter.c"
				}
			}
#line 651 "../src/MetadataWriter.vala"
			_tmp35_ = job;
#line 651 "../src/MetadataWriter.vala"
			_tmp36_ = _tmp35_->reimport_editable_state;
#line 651 "../src/MetadataWriter.vala"
			if (_tmp36_ != NULL) {
#line 2856 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp37_;
				LibraryPhoto* _tmp38_;
				MetadataWriterCommitJob* _tmp39_;
				PhotoReimportEditableState* _tmp40_;
#line 652 "../src/MetadataWriter.vala"
				_tmp37_ = job;
#line 652 "../src/MetadataWriter.vala"
				_tmp38_ = _tmp37_->photo;
#line 652 "../src/MetadataWriter.vala"
				_tmp39_ = job;
#line 652 "../src/MetadataWriter.vala"
				_tmp40_ = _tmp39_->reimport_editable_state;
#line 652 "../src/MetadataWriter.vala"
				photo_finish_update_editable_metadata ((Photo*) _tmp38_, _tmp40_, &_inner_error0_);
#line 652 "../src/MetadataWriter.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 652 "../src/MetadataWriter.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2875 "MetadataWriter.c"
						goto __catch0_database_error;
					}
#line 652 "../src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 652 "../src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 652 "../src/MetadataWriter.vala"
					g_clear_error (&_inner_error0_);
#line 652 "../src/MetadataWriter.vala"
					return;
#line 2886 "MetadataWriter.c"
				}
			}
		}
		goto __finally0;
		__catch0_database_error:
		{
			GError* err = NULL;
			GError* _tmp41_;
#line 647 "../src/MetadataWriter.vala"
			err = _inner_error0_;
#line 647 "../src/MetadataWriter.vala"
			_inner_error0_ = NULL;
#line 654 "../src/MetadataWriter.vala"
			_tmp41_ = err;
#line 654 "../src/MetadataWriter.vala"
			app_window_database_error (_tmp41_);
#line 647 "../src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 2905 "MetadataWriter.c"
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			LibraryPhoto* _tmp42_;
			MetadataWriterCommitJob* _tmp43_;
			LibraryPhoto* _tmp44_;
#line 657 "../src/MetadataWriter.vala"
			_tmp42_ = self->priv->ignore_photo_alteration;
#line 657 "../src/MetadataWriter.vala"
			_tmp43_ = job;
#line 657 "../src/MetadataWriter.vala"
			_tmp44_ = _tmp43_->photo;
#line 657 "../src/MetadataWriter.vala"
			_vala_assert (_tmp42_ == _tmp44_, "ignore_photo_alteration == job.photo");
#line 658 "../src/MetadataWriter.vala"
			_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 658 "../src/MetadataWriter.vala"
			self->priv->ignore_photo_alteration = NULL;
#line 2925 "MetadataWriter.c"
		}
#line 647 "../src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 647 "../src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 647 "../src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 647 "../src/MetadataWriter.vala"
			g_clear_error (&_inner_error0_);
#line 647 "../src/MetadataWriter.vala"
			return;
#line 2937 "MetadataWriter.c"
		}
	} else {
	}
	{
		MetadataWriterCommitJob* _tmp45_;
		LibraryPhoto* _tmp46_;
#line 668 "../src/MetadataWriter.vala"
		_tmp45_ = job;
#line 668 "../src/MetadataWriter.vala"
		_tmp46_ = _tmp45_->photo;
#line 668 "../src/MetadataWriter.vala"
		photo_set_master_metadata_dirty ((Photo*) _tmp46_, FALSE, &_inner_error0_);
#line 668 "../src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 668 "../src/MetadataWriter.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2954 "MetadataWriter.c"
				goto __catch1_database_error;
			}
#line 668 "../src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 668 "../src/MetadataWriter.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 668 "../src/MetadataWriter.vala"
			g_clear_error (&_inner_error0_);
#line 668 "../src/MetadataWriter.vala"
			return;
#line 2965 "MetadataWriter.c"
		}
	}
	goto __finally1;
	__catch1_database_error:
	{
		GError* err = NULL;
		GError* _tmp47_;
#line 667 "../src/MetadataWriter.vala"
		err = _inner_error0_;
#line 667 "../src/MetadataWriter.vala"
		_inner_error0_ = NULL;
#line 670 "../src/MetadataWriter.vala"
		_tmp47_ = err;
#line 670 "../src/MetadataWriter.vala"
		app_window_database_error (_tmp47_);
#line 667 "../src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 2983 "MetadataWriter.c"
	}
	__finally1:
#line 667 "../src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 667 "../src/MetadataWriter.vala"
		_background_job_unref0 (job);
#line 667 "../src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 667 "../src/MetadataWriter.vala"
		g_clear_error (&_inner_error0_);
#line 667 "../src/MetadataWriter.vala"
		return;
#line 2996 "MetadataWriter.c"
	}
#line 673 "../src/MetadataWriter.vala"
	_tmp48_ = library_photo_global;
#line 673 "../src/MetadataWriter.vala"
	_tmp49_ = media_source_collection_get_transaction_controller ((MediaSourceCollection*) _tmp48_);
#line 673 "../src/MetadataWriter.vala"
	_tmp50_ = _tmp49_;
#line 673 "../src/MetadataWriter.vala"
	transaction_controller_commit (_tmp50_);
#line 675 "../src/MetadataWriter.vala"
	metadata_writer_count_completed_work (self, 1, TRUE);
#line 627 "../src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 3010 "MetadataWriter.c"
}

static void
metadata_writer_on_update_cancelled (MetadataWriter* self,
                                     BackgroundJob* j)
{
	gboolean removed = FALSE;
	GeeHashMap* _tmp0_;
	LibraryPhoto* _tmp1_;
#line 678 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 678 "../src/MetadataWriter.vala"
	g_return_if_fail (j != NULL);
#line 679 "../src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 679 "../src/MetadataWriter.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (j, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob)->photo;
#line 679 "../src/MetadataWriter.vala"
	removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _tmp1_, NULL);
#line 680 "../src/MetadataWriter.vala"
	_vala_assert (removed, "removed");
#line 682 "../src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 3034 "MetadataWriter.c"
}

static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 27 "../src/MetadataWriter.vala"
	g_return_if_fail (n_param_values == 3);
#line 27 "../src/MetadataWriter.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "../src/MetadataWriter.vala"
		data1 = closure->data;
#line 27 "../src/MetadataWriter.vala"
		data2 = param_values->data[0].v_pointer;
#line 3059 "MetadataWriter.c"
	} else {
#line 27 "../src/MetadataWriter.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "../src/MetadataWriter.vala"
		data2 = closure->data;
#line 3065 "MetadataWriter.c"
	}
#line 27 "../src/MetadataWriter.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 27 "../src/MetadataWriter.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 3071 "MetadataWriter.c"
}

static void
_metadata_writer_on_update_completed_completion_callback (BackgroundJob* job,
                                                          gpointer self)
{
#line 41 "../src/MetadataWriter.vala"
	metadata_writer_on_update_completed ((MetadataWriter*) self, job);
#line 3080 "MetadataWriter.c"
}

static void
_metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job,
                                                            gpointer self)
{
#line 41 "../src/MetadataWriter.vala"
	metadata_writer_on_update_cancelled ((MetadataWriter*) self, job);
#line 3089 "MetadataWriter.c"
}

static MetadataWriterCommitJob*
metadata_writer_commit_job_construct (GType object_type,
                                      MetadataWriter* owner,
                                      LibraryPhoto* photo,
                                      GeeSet* keywords)
{
	MetadataWriterCommitJob* self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeSet* _tmp3_;
#line 40 "../src/MetadataWriter.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 40 "../src/MetadataWriter.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 41 "../src/MetadataWriter.vala"
	_tmp0_ = g_cancellable_new ();
#line 41 "../src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 41 "../src/MetadataWriter.vala"
	self = (MetadataWriterCommitJob*) background_job_construct (object_type, (GObject*) owner, _metadata_writer_on_update_completed_completion_callback, owner, _tmp1_, _metadata_writer_on_update_cancelled_cancellation_callback, owner, NULL);
#line 41 "../src/MetadataWriter.vala"
	_g_object_unref0 (_tmp1_);
#line 43 "../src/MetadataWriter.vala"
	_tmp2_ = _g_object_ref0 (photo);
#line 43 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 43 "../src/MetadataWriter.vala"
	self->photo = _tmp2_;
#line 44 "../src/MetadataWriter.vala"
	_tmp3_ = _g_object_ref0 (keywords);
#line 44 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 44 "../src/MetadataWriter.vala"
	self->current_keywords = _tmp3_;
#line 40 "../src/MetadataWriter.vala"
	return self;
#line 3129 "MetadataWriter.c"
}

static MetadataWriterCommitJob*
metadata_writer_commit_job_new (MetadataWriter* owner,
                                LibraryPhoto* photo,
                                GeeSet* keywords)
{
#line 40 "../src/MetadataWriter.vala"
	return metadata_writer_commit_job_construct (METADATA_WRITER_TYPE_COMMIT_JOB, owner, photo, keywords);
#line 3139 "MetadataWriter.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 52 "../src/MetadataWriter.vala"
	return self ? g_error_copy (self) : NULL;
#line 3147 "MetadataWriter.c"
}

static void
metadata_writer_commit_job_real_execute (BackgroundJob* base)
{
	MetadataWriterCommitJob * self;
	GError* _inner_error0_ = NULL;
#line 47 "../src/MetadataWriter.vala"
	self = (MetadataWriterCommitJob*) base;
#line 3157 "MetadataWriter.c"
	{
#line 49 "../src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_master (self, &_inner_error0_);
#line 49 "../src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3163 "MetadataWriter.c"
			goto __catch0_g_error;
		}
#line 50 "../src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_editable (self, &_inner_error0_);
#line 50 "../src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3170 "MetadataWriter.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		GError* _tmp1_;
#line 48 "../src/MetadataWriter.vala"
		err = _inner_error0_;
#line 48 "../src/MetadataWriter.vala"
		_inner_error0_ = NULL;
#line 52 "../src/MetadataWriter.vala"
		_tmp0_ = err;
#line 52 "../src/MetadataWriter.vala"
		_tmp1_ = _g_error_copy0 (_tmp0_);
#line 52 "../src/MetadataWriter.vala"
		_g_error_free0 (self->err);
#line 52 "../src/MetadataWriter.vala"
		self->err = _tmp1_;
#line 48 "../src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 3194 "MetadataWriter.c"
	}
	__finally0:
#line 48 "../src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/MetadataWriter.vala"
		g_clear_error (&_inner_error0_);
#line 48 "../src/MetadataWriter.vala"
		return;
#line 3205 "MetadataWriter.c"
	}
}

static void
metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self,
                                          GError** error)
{
	gboolean skip_orientation = FALSE;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	PhotoMetadata* metadata = NULL;
	LibraryPhoto* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 56 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 60 "../src/MetadataWriter.vala"
	skip_orientation = photo_has_editable ((Photo*) _tmp0_);
#line 62 "../src/MetadataWriter.vala"
	_tmp1_ = self->photo;
#line 62 "../src/MetadataWriter.vala"
	if (!photo_file_format_can_write_metadata (photo_get_master_file_format ((Photo*) _tmp1_))) {
#line 63 "../src/MetadataWriter.vala"
		return;
#line 3233 "MetadataWriter.c"
	}
#line 65 "../src/MetadataWriter.vala"
	_tmp2_ = self->photo;
#line 65 "../src/MetadataWriter.vala"
	_tmp3_ = photo_get_master_metadata ((Photo*) _tmp2_, &_inner_error0_);
#line 65 "../src/MetadataWriter.vala"
	metadata = _tmp3_;
#line 65 "../src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error0_);
#line 65 "../src/MetadataWriter.vala"
		return;
#line 3247 "MetadataWriter.c"
	}
#line 66 "../src/MetadataWriter.vala"
	_tmp4_ = metadata;
#line 66 "../src/MetadataWriter.vala"
	if (metadata_writer_commit_job_update_metadata (self, _tmp4_, skip_orientation)) {
#line 3253 "MetadataWriter.c"
		LibraryPhoto* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 67 "../src/MetadataWriter.vala"
		_tmp5_ = self->photo;
#line 67 "../src/MetadataWriter.vala"
		_tmp6_ = media_source_get_master_file ((MediaSource*) _tmp5_);
#line 67 "../src/MetadataWriter.vala"
		_tmp7_ = _tmp6_;
#line 67 "../src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp7_, "MetadataWriter.commit_master");
#line 67 "../src/MetadataWriter.vala"
		_g_object_unref0 (_tmp7_);
#line 3267 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp8_;
			PhotoMetadata* _tmp9_;
			PhotoReimportMasterState* _tmp10_ = NULL;
#line 69 "../src/MetadataWriter.vala"
			_tmp8_ = self->photo;
#line 69 "../src/MetadataWriter.vala"
			_tmp9_ = metadata;
#line 69 "../src/MetadataWriter.vala"
			photo_persist_master_metadata ((Photo*) _tmp8_, _tmp9_, &_tmp10_, &_inner_error0_);
#line 69 "../src/MetadataWriter.vala"
			_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 69 "../src/MetadataWriter.vala"
			self->reimport_master_state = _tmp10_;
#line 69 "../src/MetadataWriter.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3284 "MetadataWriter.c"
				goto __finally0;
			}
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			LibraryPhoto* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
#line 71 "../src/MetadataWriter.vala"
			_tmp11_ = self->photo;
#line 71 "../src/MetadataWriter.vala"
			_tmp12_ = media_source_get_master_file ((MediaSource*) _tmp11_);
#line 71 "../src/MetadataWriter.vala"
			_tmp13_ = _tmp12_;
#line 71 "../src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp13_);
#line 71 "../src/MetadataWriter.vala"
			_g_object_unref0 (_tmp13_);
#line 3304 "MetadataWriter.c"
		}
#line 68 "../src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error0_);
#line 68 "../src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 68 "../src/MetadataWriter.vala"
			return;
#line 3314 "MetadataWriter.c"
		}
	}
#line 56 "../src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 3319 "MetadataWriter.c"
}

static void
metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self,
                                            GError** error)
{
	gboolean _tmp0_ = FALSE;
	LibraryPhoto* _tmp1_;
	PhotoMetadata* metadata = NULL;
	LibraryPhoto* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 76 "../src/MetadataWriter.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/MetadataWriter.vala"
	_tmp1_ = self->photo;
#line 77 "../src/MetadataWriter.vala"
	if (!photo_has_editable ((Photo*) _tmp1_)) {
#line 77 "../src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 3342 "MetadataWriter.c"
	} else {
		LibraryPhoto* _tmp2_;
		PhotoFileFormat* _tmp3_;
		PhotoFileFormat* _tmp4_;
#line 77 "../src/MetadataWriter.vala"
		_tmp2_ = self->photo;
#line 77 "../src/MetadataWriter.vala"
		_tmp3_ = photo_get_editable_file_format ((Photo*) _tmp2_);
#line 77 "../src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 77 "../src/MetadataWriter.vala"
		_tmp0_ = !photo_file_format_can_write_metadata (*_tmp4_);
#line 77 "../src/MetadataWriter.vala"
		_g_free0 (_tmp4_);
#line 3357 "MetadataWriter.c"
	}
#line 77 "../src/MetadataWriter.vala"
	if (_tmp0_) {
#line 78 "../src/MetadataWriter.vala"
		return;
#line 3363 "MetadataWriter.c"
	}
#line 80 "../src/MetadataWriter.vala"
	_tmp5_ = self->photo;
#line 80 "../src/MetadataWriter.vala"
	_tmp6_ = photo_get_editable_metadata ((Photo*) _tmp5_, &_inner_error0_);
#line 80 "../src/MetadataWriter.vala"
	metadata = _tmp6_;
#line 80 "../src/MetadataWriter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 80 "../src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error0_);
#line 80 "../src/MetadataWriter.vala"
		return;
#line 3377 "MetadataWriter.c"
	}
#line 81 "../src/MetadataWriter.vala"
	_tmp7_ = metadata;
#line 81 "../src/MetadataWriter.vala"
	_vala_assert (_tmp7_ != NULL, "metadata != null");
#line 83 "../src/MetadataWriter.vala"
	_tmp8_ = metadata;
#line 83 "../src/MetadataWriter.vala"
	if (metadata_writer_commit_job_update_metadata (self, _tmp8_, FALSE)) {
#line 3387 "MetadataWriter.c"
		LibraryPhoto* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 84 "../src/MetadataWriter.vala"
		_tmp9_ = self->photo;
#line 84 "../src/MetadataWriter.vala"
		_tmp10_ = photo_get_editable_file ((Photo*) _tmp9_);
#line 84 "../src/MetadataWriter.vala"
		_tmp11_ = _tmp10_;
#line 84 "../src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp11_, "MetadataWriter.commit_editable");
#line 84 "../src/MetadataWriter.vala"
		_g_object_unref0 (_tmp11_);
#line 3401 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp12_;
			PhotoMetadata* _tmp13_;
			PhotoReimportEditableState* _tmp14_ = NULL;
#line 86 "../src/MetadataWriter.vala"
			_tmp12_ = self->photo;
#line 86 "../src/MetadataWriter.vala"
			_tmp13_ = metadata;
#line 86 "../src/MetadataWriter.vala"
			photo_persist_editable_metadata ((Photo*) _tmp12_, _tmp13_, &_tmp14_, &_inner_error0_);
#line 86 "../src/MetadataWriter.vala"
			_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 86 "../src/MetadataWriter.vala"
			self->reimport_editable_state = _tmp14_;
#line 86 "../src/MetadataWriter.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3418 "MetadataWriter.c"
				goto __finally0;
			}
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			LibraryPhoto* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_;
#line 88 "../src/MetadataWriter.vala"
			_tmp15_ = self->photo;
#line 88 "../src/MetadataWriter.vala"
			_tmp16_ = photo_get_editable_file ((Photo*) _tmp15_);
#line 88 "../src/MetadataWriter.vala"
			_tmp17_ = _tmp16_;
#line 88 "../src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp17_);
#line 88 "../src/MetadataWriter.vala"
			_g_object_unref0 (_tmp17_);
#line 3438 "MetadataWriter.c"
		}
#line 85 "../src/MetadataWriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error0_);
#line 85 "../src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 85 "../src/MetadataWriter.vala"
			return;
#line 3448 "MetadataWriter.c"
		}
	}
#line 76 "../src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 3453 "MetadataWriter.c"
}

static gboolean
metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self,
                                            PhotoMetadata* metadata,
                                            gboolean skip_orientation)
{
	gboolean changed = FALSE;
	gchar* current_title = NULL;
	LibraryPhoto* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gchar* current_comment = NULL;
	LibraryPhoto* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
	gint64 current_exposure_time = 0LL;
	LibraryPhoto* _tmp14_;
	gint64 metadata_exposure_time = 0LL;
	MetadataDateTime* metadata_exposure_date_time = NULL;
	MetadataDateTime* _tmp15_;
	MetadataDateTime* _tmp16_;
	GeeSet* safe_keywords = NULL;
	GeeHashSet* _tmp20_;
	GeeSet* _tmp21_;
	GeeSet* _tmp33_;
	GeeSet* _tmp34_;
	GeeSet* _tmp35_;
	gboolean _tmp36_;
	gboolean result;
#line 93 "../src/MetadataWriter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/MetadataWriter.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 94 "../src/MetadataWriter.vala"
	changed = FALSE;
#line 97 "../src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 97 "../src/MetadataWriter.vala"
	_tmp1_ = media_source_get_title ((MediaSource*) _tmp0_);
#line 97 "../src/MetadataWriter.vala"
	current_title = _tmp1_;
#line 98 "../src/MetadataWriter.vala"
	_tmp2_ = current_title;
#line 98 "../src/MetadataWriter.vala"
	_tmp3_ = media_metadata_get_title ((MediaMetadata*) metadata);
#line 98 "../src/MetadataWriter.vala"
	_tmp4_ = _tmp3_;
#line 98 "../src/MetadataWriter.vala"
	_tmp5_ = g_strcmp0 (_tmp2_, _tmp4_) != 0;
#line 98 "../src/MetadataWriter.vala"
	_g_free0 (_tmp4_);
#line 98 "../src/MetadataWriter.vala"
	if (_tmp5_) {
#line 3514 "MetadataWriter.c"
		const gchar* _tmp6_;
#line 99 "../src/MetadataWriter.vala"
		_tmp6_ = current_title;
#line 99 "../src/MetadataWriter.vala"
		photo_metadata_set_title (metadata, _tmp6_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 100 "../src/MetadataWriter.vala"
		changed = TRUE;
#line 3522 "MetadataWriter.c"
	}
#line 104 "../src/MetadataWriter.vala"
	_tmp7_ = self->photo;
#line 104 "../src/MetadataWriter.vala"
	_tmp8_ = media_source_get_comment ((MediaSource*) _tmp7_);
#line 104 "../src/MetadataWriter.vala"
	current_comment = _tmp8_;
#line 105 "../src/MetadataWriter.vala"
	_tmp9_ = current_comment;
#line 105 "../src/MetadataWriter.vala"
	_tmp10_ = media_metadata_get_comment ((MediaMetadata*) metadata);
#line 105 "../src/MetadataWriter.vala"
	_tmp11_ = _tmp10_;
#line 105 "../src/MetadataWriter.vala"
	_tmp12_ = g_strcmp0 (_tmp9_, _tmp11_) != 0;
#line 105 "../src/MetadataWriter.vala"
	_g_free0 (_tmp11_);
#line 105 "../src/MetadataWriter.vala"
	if (_tmp12_) {
#line 3542 "MetadataWriter.c"
		const gchar* _tmp13_;
#line 106 "../src/MetadataWriter.vala"
		_tmp13_ = current_comment;
#line 106 "../src/MetadataWriter.vala"
		photo_metadata_set_comment (metadata, _tmp13_);
#line 107 "../src/MetadataWriter.vala"
		changed = TRUE;
#line 3550 "MetadataWriter.c"
	}
#line 111 "../src/MetadataWriter.vala"
	_tmp14_ = self->photo;
#line 111 "../src/MetadataWriter.vala"
	current_exposure_time = media_source_get_exposure_time ((MediaSource*) _tmp14_);
#line 112 "../src/MetadataWriter.vala"
	metadata_exposure_time = (gint64) 0;
#line 113 "../src/MetadataWriter.vala"
	_tmp15_ = photo_metadata_get_exposure_date_time (metadata);
#line 113 "../src/MetadataWriter.vala"
	metadata_exposure_date_time = _tmp15_;
#line 114 "../src/MetadataWriter.vala"
	_tmp16_ = metadata_exposure_date_time;
#line 114 "../src/MetadataWriter.vala"
	if (_tmp16_ != NULL) {
#line 3566 "MetadataWriter.c"
		MetadataDateTime* _tmp17_;
#line 115 "../src/MetadataWriter.vala"
		_tmp17_ = metadata_exposure_date_time;
#line 115 "../src/MetadataWriter.vala"
		metadata_exposure_time = metadata_date_time_get_timestamp (_tmp17_);
#line 3572 "MetadataWriter.c"
	}
#line 116 "../src/MetadataWriter.vala"
	if (current_exposure_time != metadata_exposure_time) {
#line 3576 "MetadataWriter.c"
		MetadataDateTime* _tmp18_ = NULL;
#line 117 "../src/MetadataWriter.vala"
		if (current_exposure_time != ((gint64) 0)) {
#line 3580 "MetadataWriter.c"
			MetadataDateTime* _tmp19_;
#line 118 "../src/MetadataWriter.vala"
			_tmp19_ = metadata_date_time_new (current_exposure_time);
#line 118 "../src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp18_);
#line 118 "../src/MetadataWriter.vala"
			_tmp18_ = _tmp19_;
#line 3588 "MetadataWriter.c"
		} else {
#line 119 "../src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp18_);
#line 119 "../src/MetadataWriter.vala"
			_tmp18_ = NULL;
#line 3594 "MetadataWriter.c"
		}
#line 117 "../src/MetadataWriter.vala"
		photo_metadata_set_exposure_date_time (metadata, _tmp18_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 120 "../src/MetadataWriter.vala"
		changed = TRUE;
#line 116 "../src/MetadataWriter.vala"
		_metadata_date_time_unref0 (_tmp18_);
#line 3602 "MetadataWriter.c"
	}
#line 124 "../src/MetadataWriter.vala"
	_tmp20_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 124 "../src/MetadataWriter.vala"
	safe_keywords = (GeeSet*) _tmp20_;
#line 133 "../src/MetadataWriter.vala"
	_tmp21_ = self->current_keywords;
#line 133 "../src/MetadataWriter.vala"
	if (_tmp21_ != NULL) {
#line 3612 "MetadataWriter.c"
		{
			GeeIterator* _tmp_it = NULL;
			GeeSet* _tmp22_;
			GeeIterator* _tmp23_;
#line 134 "../src/MetadataWriter.vala"
			_tmp22_ = self->current_keywords;
#line 134 "../src/MetadataWriter.vala"
			_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 134 "../src/MetadataWriter.vala"
			_tmp_it = _tmp23_;
#line 134 "../src/MetadataWriter.vala"
			while (TRUE) {
#line 3625 "MetadataWriter.c"
				GeeIterator* _tmp24_;
				gchar* tmp = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				Tag* tag = NULL;
				const gchar* _tmp27_;
				Tag* _tmp28_;
				GeeSet* _tmp29_;
				Tag* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
#line 134 "../src/MetadataWriter.vala"
				_tmp24_ = _tmp_it;
#line 134 "../src/MetadataWriter.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 134 "../src/MetadataWriter.vala"
					break;
#line 3643 "MetadataWriter.c"
				}
#line 134 "../src/MetadataWriter.vala"
				_tmp25_ = _tmp_it;
#line 134 "../src/MetadataWriter.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 134 "../src/MetadataWriter.vala"
				tmp = (gchar*) _tmp26_;
#line 135 "../src/MetadataWriter.vala"
				_tmp27_ = tmp;
#line 135 "../src/MetadataWriter.vala"
				_tmp28_ = tag_for_path (_tmp27_);
#line 135 "../src/MetadataWriter.vala"
				tag = _tmp28_;
#line 136 "../src/MetadataWriter.vala"
				_tmp29_ = safe_keywords;
#line 136 "../src/MetadataWriter.vala"
				_tmp30_ = tag;
#line 136 "../src/MetadataWriter.vala"
				_tmp31_ = tag_get_user_visible_name (_tmp30_);
#line 136 "../src/MetadataWriter.vala"
				_tmp32_ = _tmp31_;
#line 136 "../src/MetadataWriter.vala"
				gee_collection_add ((GeeCollection*) _tmp29_, _tmp32_);
#line 136 "../src/MetadataWriter.vala"
				_g_free0 (_tmp32_);
#line 134 "../src/MetadataWriter.vala"
				_g_object_unref0 (tag);
#line 134 "../src/MetadataWriter.vala"
				_g_free0 (tmp);
#line 3673 "MetadataWriter.c"
			}
#line 134 "../src/MetadataWriter.vala"
			_g_object_unref0 (_tmp_it);
#line 3677 "MetadataWriter.c"
		}
	}
#line 140 "../src/MetadataWriter.vala"
	_tmp33_ = safe_keywords;
#line 140 "../src/MetadataWriter.vala"
	_tmp34_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 140 "../src/MetadataWriter.vala"
	_tmp35_ = _tmp34_;
#line 140 "../src/MetadataWriter.vala"
	_tmp36_ = !equal_sets (_tmp33_, _tmp35_);
#line 140 "../src/MetadataWriter.vala"
	_g_object_unref0 (_tmp35_);
#line 140 "../src/MetadataWriter.vala"
	if (_tmp36_) {
#line 3692 "MetadataWriter.c"
		GeeSet* _tmp37_;
#line 141 "../src/MetadataWriter.vala"
		_tmp37_ = self->current_keywords;
#line 141 "../src/MetadataWriter.vala"
		photo_metadata_set_keywords (metadata, (GeeCollection*) _tmp37_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 142 "../src/MetadataWriter.vala"
		changed = TRUE;
#line 3700 "MetadataWriter.c"
	}
#line 146 "../src/MetadataWriter.vala"
	if (!skip_orientation) {
#line 3704 "MetadataWriter.c"
		Orientation current_orientation = 0;
		LibraryPhoto* _tmp38_;
#line 147 "../src/MetadataWriter.vala"
		_tmp38_ = self->photo;
#line 147 "../src/MetadataWriter.vala"
		current_orientation = photo_get_orientation ((Photo*) _tmp38_);
#line 148 "../src/MetadataWriter.vala"
		if (current_orientation != photo_metadata_get_orientation (metadata)) {
#line 149 "../src/MetadataWriter.vala"
			photo_metadata_set_orientation (metadata, current_orientation);
#line 150 "../src/MetadataWriter.vala"
			changed = TRUE;
#line 3717 "MetadataWriter.c"
		}
	}
#line 155 "../src/MetadataWriter.vala"
	if (changed) {
#line 156 "../src/MetadataWriter.vala"
		photo_metadata_set_software (metadata, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 3724 "MetadataWriter.c"
	}
#line 158 "../src/MetadataWriter.vala"
	result = changed;
#line 158 "../src/MetadataWriter.vala"
	_g_object_unref0 (safe_keywords);
#line 158 "../src/MetadataWriter.vala"
	_metadata_date_time_unref0 (metadata_exposure_date_time);
#line 158 "../src/MetadataWriter.vala"
	_g_free0 (current_comment);
#line 158 "../src/MetadataWriter.vala"
	_g_free0 (current_title);
#line 158 "../src/MetadataWriter.vala"
	return result;
#line 3738 "MetadataWriter.c"
}

static void
metadata_writer_commit_job_class_init (MetadataWriterCommitJobClass * klass,
                                       gpointer klass_data)
{
#line 33 "../src/MetadataWriter.vala"
	metadata_writer_commit_job_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/MetadataWriter.vala"
	((BackgroundJobClass *) klass)->finalize = metadata_writer_commit_job_finalize;
#line 33 "../src/MetadataWriter.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) metadata_writer_commit_job_real_execute;
#line 3751 "MetadataWriter.c"
}

static void
metadata_writer_commit_job_instance_init (MetadataWriterCommitJob * self,
                                          gpointer klass)
{
#line 36 "../src/MetadataWriter.vala"
	self->reimport_master_state = NULL;
#line 37 "../src/MetadataWriter.vala"
	self->reimport_editable_state = NULL;
#line 38 "../src/MetadataWriter.vala"
	self->err = NULL;
#line 3764 "MetadataWriter.c"
}

static void
metadata_writer_commit_job_finalize (BackgroundJob * obj)
{
	MetadataWriterCommitJob * self;
#line 33 "../src/MetadataWriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob);
#line 34 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 35 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 36 "../src/MetadataWriter.vala"
	_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 37 "../src/MetadataWriter.vala"
	_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 38 "../src/MetadataWriter.vala"
	_g_error_free0 (self->err);
#line 33 "../src/MetadataWriter.vala"
	BACKGROUND_JOB_CLASS (metadata_writer_commit_job_parent_class)->finalize (obj);
#line 3785 "MetadataWriter.c"
}

static GType
metadata_writer_commit_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterCommitJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_commit_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriterCommitJob), 0, (GInstanceInitFunc) metadata_writer_commit_job_instance_init, NULL };
	GType metadata_writer_commit_job_type_id;
	metadata_writer_commit_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "MetadataWriterCommitJob", &g_define_type_info, 0);
	return metadata_writer_commit_job_type_id;
}

static GType
metadata_writer_commit_job_get_type (void)
{
	static volatile gsize metadata_writer_commit_job_type_id__once = 0;
	if (g_once_init_enter (&metadata_writer_commit_job_type_id__once)) {
		GType metadata_writer_commit_job_type_id;
		metadata_writer_commit_job_type_id = metadata_writer_commit_job_get_type_once ();
		g_once_init_leave (&metadata_writer_commit_job_type_id__once, metadata_writer_commit_job_type_id);
	}
	return metadata_writer_commit_job_type_id__once;
}

static void
metadata_writer_class_init (MetadataWriterClass * klass,
                            gpointer klass_data)
{
#line 27 "../src/MetadataWriter.vala"
	metadata_writer_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/MetadataWriter.vala"
	g_type_class_adjust_private_offset (klass, &MetadataWriter_private_offset);
#line 27 "../src/MetadataWriter.vala"
	G_OBJECT_CLASS (klass)->finalize = metadata_writer_finalize;
#line 27 "../src/MetadataWriter.vala"
	metadata_writer_signals[METADATA_WRITER_PROGRESS_SIGNAL] = g_signal_new ("progress", TYPE_METADATA_WRITER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 3821 "MetadataWriter.c"
}

static void
metadata_writer_instance_init (MetadataWriter * self,
                               gpointer klass)
{
	Workers* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp3_;
#line 27 "../src/MetadataWriter.vala"
	self->priv = metadata_writer_get_instance_private (self);
#line 164 "../src/MetadataWriter.vala"
	_tmp0_ = workers_new (1, FALSE);
#line 164 "../src/MetadataWriter.vala"
	self->priv->workers = _tmp0_;
#line 165 "../src/MetadataWriter.vala"
	self->priv->enabled = FALSE;
#line 167 "../src/MetadataWriter.vala"
	_tmp1_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, METADATA_WRITER_TYPE_COMMIT_JOB, (GBoxedCopyFunc) background_job_ref, (GDestroyNotify) background_job_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 167 "../src/MetadataWriter.vala"
	self->priv->pending = _tmp1_;
#line 168 "../src/MetadataWriter.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 168 "../src/MetadataWriter.vala"
	self->priv->interested_photo_details = _tmp2_;
#line 169 "../src/MetadataWriter.vala"
	self->priv->ignore_photo_alteration = NULL;
#line 170 "../src/MetadataWriter.vala"
	self->priv->outstanding_total = (guint) 0;
#line 171 "../src/MetadataWriter.vala"
	self->priv->outstanding_completed = (guint) 0;
#line 172 "../src/MetadataWriter.vala"
	self->priv->closed = FALSE;
#line 173 "../src/MetadataWriter.vala"
	self->priv->pause_count = 0;
#line 174 "../src/MetadataWriter.vala"
	_tmp3_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 174 "../src/MetadataWriter.vala"
	self->priv->importing_photos = _tmp3_;
#line 3862 "MetadataWriter.c"
}

static void
metadata_writer_finalize (GObject * obj)
{
	MetadataWriter * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
	LibraryPhotoSourceCollection* _tmp2_;
	guint _tmp3_;
	LibraryPhotoSourceCollection* _tmp4_;
	guint _tmp5_;
	LibraryPhotoSourceCollection* _tmp6_;
	guint _tmp7_;
	LibraryPhotoSourceCollection* _tmp8_;
	guint _tmp9_;
	LibraryPhotoSourceCollection* _tmp10_;
	guint _tmp11_;
	LibraryPhotoSourceCollection* _tmp12_;
	guint _tmp13_;
	TagSourceCollection* _tmp14_;
	guint _tmp15_;
	TagSourceCollection* _tmp16_;
	guint _tmp17_;
	TagSourceCollection* _tmp18_;
	guint _tmp19_;
	TagSourceCollection* _tmp20_;
	guint _tmp21_;
	TagSourceCollection* _tmp22_;
	guint _tmp23_;
	GApplication* _tmp24_;
	guint _tmp25_;
	LibraryMonitorPool* _tmp26_;
	LibraryMonitorPool* _tmp27_;
	guint _tmp28_;
	LibraryMonitorPool* _tmp29_;
	LibraryMonitorPool* _tmp30_;
	guint _tmp31_;
#line 27 "../src/MetadataWriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_METADATA_WRITER, MetadataWriter);
#line 221 "../src/MetadataWriter.vala"
	_tmp0_ = library_photo_global;
#line 221 "../src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-starting", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 221 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((MediaSourceCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self);
#line 222 "../src/MetadataWriter.vala"
	_tmp2_ = library_photo_global;
#line 222 "../src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-completed", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 222 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((MediaSourceCollection*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self);
#line 223 "../src/MetadataWriter.vala"
	_tmp4_ = library_photo_global;
#line 223 "../src/MetadataWriter.vala"
	g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 223 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self);
#line 224 "../src/MetadataWriter.vala"
	_tmp6_ = library_photo_global;
#line 224 "../src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp7_, NULL, FALSE);
#line 224 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self);
#line 225 "../src/MetadataWriter.vala"
	_tmp8_ = library_photo_global;
#line 225 "../src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp9_, NULL, FALSE);
#line 225 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 226 "../src/MetadataWriter.vala"
	_tmp10_ = library_photo_global;
#line 226 "../src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp11_, NULL, FALSE);
#line 226 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 227 "../src/MetadataWriter.vala"
	_tmp12_ = library_photo_global;
#line 227 "../src/MetadataWriter.vala"
	g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp13_, NULL, FALSE);
#line 227 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((SourceCollection*) _tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self);
#line 229 "../src/MetadataWriter.vala"
	_tmp14_ = tag_global;
#line 229 "../src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp15_, NULL, FALSE);
#line 229 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self);
#line 230 "../src/MetadataWriter.vala"
	_tmp16_ = tag_global;
#line 230 "../src/MetadataWriter.vala"
	g_signal_parse_name ("container-contents-altered", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp17_, NULL, FALSE);
#line 230 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((ContainerSourceCollection*) _tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self);
#line 231 "../src/MetadataWriter.vala"
	_tmp18_ = tag_global;
#line 231 "../src/MetadataWriter.vala"
	g_signal_parse_name ("backlink-to-container-removed", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp19_, NULL, FALSE);
#line 231 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((ContainerSourceCollection*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self);
#line 232 "../src/MetadataWriter.vala"
	_tmp20_ = tag_global;
#line 232 "../src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp21_, NULL, FALSE);
#line 232 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 233 "../src/MetadataWriter.vala"
	_tmp22_ = tag_global;
#line 233 "../src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp23_, NULL, FALSE);
#line 233 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 235 "../src/MetadataWriter.vala"
	_tmp24_ = g_application_get_default ();
#line 235 "../src/MetadataWriter.vala"
	g_signal_parse_name ("exiting", PHOTOS_TYPE_APPLICATION, &_tmp25_, NULL, FALSE);
#line 235 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, PHOTOS_TYPE_APPLICATION, PhotosApplication), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _metadata_writer_on_application_exiting_photos_application_exiting, self);
#line 237 "../src/MetadataWriter.vala"
	_tmp26_ = library_monitor_pool_get_instance ();
#line 237 "../src/MetadataWriter.vala"
	_tmp27_ = _tmp26_;
#line 237 "../src/MetadataWriter.vala"
	g_signal_parse_name ("monitor-installed", TYPE_LIBRARY_MONITOR_POOL, &_tmp28_, NULL, FALSE);
#line 237 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp27_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp28_, 0, NULL, (GCallback) _metadata_writer_on_monitor_installed_library_monitor_pool_monitor_installed, self);
#line 237 "../src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp27_);
#line 238 "../src/MetadataWriter.vala"
	_tmp29_ = library_monitor_pool_get_instance ();
#line 238 "../src/MetadataWriter.vala"
	_tmp30_ = _tmp29_;
#line 238 "../src/MetadataWriter.vala"
	g_signal_parse_name ("monitor-destroyed", TYPE_LIBRARY_MONITOR_POOL, &_tmp31_, NULL, FALSE);
#line 238 "../src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp30_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp31_, 0, NULL, (GCallback) _metadata_writer_on_monitor_destroyed_library_monitor_pool_monitor_destroyed, self);
#line 238 "../src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp30_);
#line 164 "../src/MetadataWriter.vala"
	_workers_unref0 (self->priv->workers);
#line 166 "../src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 167 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->pending);
#line 168 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->interested_photo_details);
#line 169 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 174 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->importing_photos);
#line 175 "../src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 27 "../src/MetadataWriter.vala"
	G_OBJECT_CLASS (metadata_writer_parent_class)->finalize (obj);
#line 4017 "MetadataWriter.c"
}

static GType
metadata_writer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriter), 0, (GInstanceInitFunc) metadata_writer_instance_init, NULL };
	GType metadata_writer_type_id;
	metadata_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "MetadataWriter", &g_define_type_info, 0);
	MetadataWriter_private_offset = g_type_add_instance_private (metadata_writer_type_id, sizeof (MetadataWriterPrivate));
	return metadata_writer_type_id;
}

GType
metadata_writer_get_type (void)
{
	static volatile gsize metadata_writer_type_id__once = 0;
	if (g_once_init_enter (&metadata_writer_type_id__once)) {
		GType metadata_writer_type_id;
		metadata_writer_type_id = metadata_writer_get_type_once ();
		g_once_init_leave (&metadata_writer_type_id__once, metadata_writer_type_id);
	}
	return metadata_writer_type_id__once;
}

