/* BackgroundJob.c generated by valac 0.56.14, the Vala compiler
 * generated from BackgroundJob.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* This callback is executed when an associated BackgroundJob completes.  It is called from within*/
/* the Gtk event loop, *not* the background thread's context.*/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <string.h>

typedef struct _ParamSpecNotificationObject ParamSpecNotificationObject;
#define _abstract_semaphore_unref0(var) ((var == NULL) ? NULL : (var = (abstract_semaphore_unref (var), NULL)))

#define BACKGROUND_JOB_TYPE_NOTIFICATION_JOB (background_job_notification_job_get_type ())
#define BACKGROUND_JOB_NOTIFICATION_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJob))
#define BACKGROUND_JOB_NOTIFICATION_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJobClass))
#define BACKGROUND_JOB_IS_NOTIFICATION_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB))
#define BACKGROUND_JOB_IS_NOTIFICATION_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB))
#define BACKGROUND_JOB_NOTIFICATION_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJobClass))

typedef struct _BackgroundJobNotificationJob BackgroundJobNotificationJob;
typedef struct _BackgroundJobNotificationJobClass BackgroundJobNotificationJobClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
#define _background_job_notification_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_notification_job_unref (var), NULL)))
#define _notification_object_unref0(var) ((var == NULL) ? NULL : (var = (notification_object_unref (var), NULL)))
typedef struct _BackgroundJobNotificationJobPrivate BackgroundJobNotificationJobPrivate;
typedef struct _BackgroundJobParamSpecNotificationJob BackgroundJobParamSpecNotificationJob;
typedef struct _ParamSpecBackgroundJob ParamSpecBackgroundJob;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecNotificationObject {
	GParamSpec parent_instance;
};

struct _InterlockedNotificationObjectPrivate {
	Semaphore* semaphore;
};

struct _BackgroundJobPrivate {
	GObject* owner;
	CompletionCallback callback;
	gpointer callback_target;
	GCancellable* cancellable;
	CancellationCallback cancellation;
	gpointer cancellation_target;
	BackgroundJob* self;
	AbstractSemaphore* semaphore;
	gint completion_priority;
	gint notification_priority;
};

struct _BackgroundJobNotificationJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobNotificationJobPrivate * priv;
	NotificationCallback callback;
	gpointer callback_target;
	BackgroundJob* background_job;
	NotificationObject* user;
};

struct _BackgroundJobNotificationJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJobNotificationJob *self);
};

struct _BackgroundJobParamSpecNotificationJob {
	GParamSpec parent_instance;
};

struct _ParamSpecBackgroundJob {
	GParamSpec parent_instance;
};

static gpointer notification_object_parent_class = NULL;
static gint InterlockedNotificationObject_private_offset;
static gpointer interlocked_notification_object_parent_class = NULL;
static gint BackgroundJob_private_offset;
static gpointer background_job_parent_class = NULL;
static GeeArrayList* background_job_notify_queue;
static GRecMutex __lock_background_job_background_job_notify_queue = {0};
static GeeArrayList* background_job_notify_queue = NULL;
static gpointer background_job_notification_job_parent_class = NULL;

static void notification_object_finalize (NotificationObject * obj);
static GType notification_object_get_type_once (void);
static void interlocked_notification_object_finalize (NotificationObject * obj);
static GType interlocked_notification_object_get_type_once (void);
static gpointer background_job_notification_job_ref (gpointer instance);
static void background_job_notification_job_unref (gpointer instance);
static GParamSpec* background_job_param_spec_notification_job (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags) G_GNUC_UNUSED ;
static void background_job_value_set_notification_job (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED ;
static void background_job_value_take_notification_job (GValue* value,
                                                 gpointer v_object) G_GNUC_UNUSED ;
static gpointer background_job_value_get_notification_job (const GValue* value) G_GNUC_UNUSED ;
static GType background_job_notification_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void background_job_real_execute (BackgroundJob* self);
static BackgroundJobJobPriority background_job_real_get_priority (BackgroundJob* self);
static gboolean background_job_on_notify_completion (BackgroundJob* self);
static gboolean _background_job_on_notify_completion_gsource_func (gpointer self);
static BackgroundJobNotificationJob* background_job_notification_job_new (NotificationCallback callback,
                                                                   gpointer callback_target,
                                                                   BackgroundJob* background_job,
                                                                   NotificationObject* user);
static BackgroundJobNotificationJob* background_job_notification_job_construct (GType object_type,
                                                                         NotificationCallback callback,
                                                                         gpointer callback_target,
                                                                         BackgroundJob* background_job,
                                                                         NotificationObject* user);
static gboolean background_job_on_notification_ready (BackgroundJob* self);
static gboolean _background_job_on_notification_ready_gsource_func (gpointer self);
static void background_job_notification_job_finalize (BackgroundJobNotificationJob * obj);
static GType background_job_notification_job_get_type_once (void);
static void background_job_finalize (BackgroundJob * obj);
static GType background_job_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

NotificationObject*
notification_object_construct (GType object_type)
{
	NotificationObject* self = NULL;
#line 47 "../src/threads/BackgroundJob.vala"
	self = (NotificationObject*) g_type_create_instance (object_type);
#line 47 "../src/threads/BackgroundJob.vala"
	return self;
#line 159 "BackgroundJob.c"
}

static void
value_notification_object_init (GValue* value)
{
#line 47 "../src/threads/BackgroundJob.vala"
	value->data[0].v_pointer = NULL;
#line 167 "BackgroundJob.c"
}

static void
value_notification_object_free_value (GValue* value)
{
#line 47 "../src/threads/BackgroundJob.vala"
	if (value->data[0].v_pointer) {
#line 47 "../src/threads/BackgroundJob.vala"
		notification_object_unref (value->data[0].v_pointer);
#line 177 "BackgroundJob.c"
	}
}

static void
value_notification_object_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 47 "../src/threads/BackgroundJob.vala"
	if (src_value->data[0].v_pointer) {
#line 47 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = notification_object_ref (src_value->data[0].v_pointer);
#line 189 "BackgroundJob.c"
	} else {
#line 47 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = NULL;
#line 193 "BackgroundJob.c"
	}
}

static gpointer
value_notification_object_peek_pointer (const GValue* value)
{
#line 47 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 202 "BackgroundJob.c"
}

static gchar*
value_notification_object_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 47 "../src/threads/BackgroundJob.vala"
	if (collect_values[0].v_pointer) {
#line 213 "BackgroundJob.c"
		NotificationObject * object;
		object = collect_values[0].v_pointer;
#line 47 "../src/threads/BackgroundJob.vala"
		if (object->parent_instance.g_class == NULL) {
#line 47 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 220 "BackgroundJob.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 47 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 224 "BackgroundJob.c"
		}
#line 47 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = notification_object_ref (object);
#line 228 "BackgroundJob.c"
	} else {
#line 47 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 232 "BackgroundJob.c"
	}
#line 47 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 236 "BackgroundJob.c"
}

static gchar*
value_notification_object_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	NotificationObject ** object_p;
	object_p = collect_values[0].v_pointer;
#line 47 "../src/threads/BackgroundJob.vala"
	if (!object_p) {
#line 47 "../src/threads/BackgroundJob.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 251 "BackgroundJob.c"
	}
#line 47 "../src/threads/BackgroundJob.vala"
	if (!value->data[0].v_pointer) {
#line 47 "../src/threads/BackgroundJob.vala"
		*object_p = NULL;
#line 257 "BackgroundJob.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 47 "../src/threads/BackgroundJob.vala"
		*object_p = value->data[0].v_pointer;
#line 261 "BackgroundJob.c"
	} else {
#line 47 "../src/threads/BackgroundJob.vala"
		*object_p = notification_object_ref (value->data[0].v_pointer);
#line 265 "BackgroundJob.c"
	}
#line 47 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 269 "BackgroundJob.c"
}

GParamSpec*
param_spec_notification_object (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecNotificationObject* spec;
#line 47 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_NOTIFICATION_OBJECT), NULL);
#line 47 "../src/threads/BackgroundJob.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 47 "../src/threads/BackgroundJob.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 47 "../src/threads/BackgroundJob.vala"
	return G_PARAM_SPEC (spec);
#line 288 "BackgroundJob.c"
}

gpointer
value_get_notification_object (const GValue* value)
{
#line 47 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_OBJECT), NULL);
#line 47 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 298 "BackgroundJob.c"
}

void
value_set_notification_object (GValue* value,
                               gpointer v_object)
{
	NotificationObject * old;
#line 47 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_OBJECT));
#line 47 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 47 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 47 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NOTIFICATION_OBJECT));
#line 47 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 47 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 47 "../src/threads/BackgroundJob.vala"
		notification_object_ref (value->data[0].v_pointer);
#line 320 "BackgroundJob.c"
	} else {
#line 47 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 324 "BackgroundJob.c"
	}
#line 47 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 47 "../src/threads/BackgroundJob.vala"
		notification_object_unref (old);
#line 330 "BackgroundJob.c"
	}
}

void
value_take_notification_object (GValue* value,
                                gpointer v_object)
{
	NotificationObject * old;
#line 47 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_OBJECT));
#line 47 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 47 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 47 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NOTIFICATION_OBJECT));
#line 47 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 47 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 351 "BackgroundJob.c"
	} else {
#line 47 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 355 "BackgroundJob.c"
	}
#line 47 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 47 "../src/threads/BackgroundJob.vala"
		notification_object_unref (old);
#line 361 "BackgroundJob.c"
	}
}

static void
notification_object_class_init (NotificationObjectClass * klass,
                                gpointer klass_data)
{
#line 47 "../src/threads/BackgroundJob.vala"
	notification_object_parent_class = g_type_class_peek_parent (klass);
#line 47 "../src/threads/BackgroundJob.vala"
	((NotificationObjectClass *) klass)->finalize = notification_object_finalize;
#line 373 "BackgroundJob.c"
}

static void
notification_object_instance_init (NotificationObject * self,
                                   gpointer klass)
{
#line 47 "../src/threads/BackgroundJob.vala"
	self->ref_count = 1;
#line 382 "BackgroundJob.c"
}

static void
notification_object_finalize (NotificationObject * obj)
{
	NotificationObject * self;
#line 47 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTIFICATION_OBJECT, NotificationObject);
#line 47 "../src/threads/BackgroundJob.vala"
	g_signal_handlers_destroy (self);
#line 393 "BackgroundJob.c"
}

static GType
notification_object_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_notification_object_init, value_notification_object_free_value, value_notification_object_copy_value, value_notification_object_peek_pointer, "p", value_notification_object_collect_value, "p", value_notification_object_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NotificationObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationObject), 0, (GInstanceInitFunc) notification_object_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType notification_object_type_id;
	notification_object_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NotificationObject", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return notification_object_type_id;
}

GType
notification_object_get_type (void)
{
	static volatile gsize notification_object_type_id__once = 0;
	if (g_once_init_enter (&notification_object_type_id__once)) {
		GType notification_object_type_id;
		notification_object_type_id = notification_object_get_type_once ();
		g_once_init_leave (&notification_object_type_id__once, notification_object_type_id);
	}
	return notification_object_type_id__once;
}

gpointer
notification_object_ref (gpointer instance)
{
	NotificationObject * self;
	self = instance;
#line 47 "../src/threads/BackgroundJob.vala"
	g_atomic_int_inc (&self->ref_count);
#line 47 "../src/threads/BackgroundJob.vala"
	return instance;
#line 428 "BackgroundJob.c"
}

void
notification_object_unref (gpointer instance)
{
	NotificationObject * self;
	self = instance;
#line 47 "../src/threads/BackgroundJob.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 47 "../src/threads/BackgroundJob.vala"
		NOTIFICATION_OBJECT_GET_CLASS (self)->finalize (self);
#line 47 "../src/threads/BackgroundJob.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 442 "BackgroundJob.c"
	}
}

static inline gpointer
interlocked_notification_object_get_instance_private (InterlockedNotificationObject* self)
{
	return G_STRUCT_MEMBER_P (self, InterlockedNotificationObject_private_offset);
}

void
interlocked_notification_object_internal_wait_for_completion (InterlockedNotificationObject* self)
{
	Semaphore* _tmp0_;
#line 54 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 55 "../src/threads/BackgroundJob.vala"
	abstract_semaphore_wait ((AbstractSemaphore*) _tmp0_);
#line 462 "BackgroundJob.c"
}

void
interlocked_notification_object_internal_completed (InterlockedNotificationObject* self)
{
	Semaphore* _tmp0_;
#line 59 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 60 "../src/threads/BackgroundJob.vala"
	abstract_semaphore_notify ((AbstractSemaphore*) _tmp0_);
#line 475 "BackgroundJob.c"
}

InterlockedNotificationObject*
interlocked_notification_object_construct (GType object_type)
{
	InterlockedNotificationObject* self = NULL;
#line 50 "../src/threads/BackgroundJob.vala"
	self = (InterlockedNotificationObject*) notification_object_construct (object_type);
#line 50 "../src/threads/BackgroundJob.vala"
	return self;
#line 486 "BackgroundJob.c"
}

static void
interlocked_notification_object_class_init (InterlockedNotificationObjectClass * klass,
                                            gpointer klass_data)
{
#line 50 "../src/threads/BackgroundJob.vala"
	interlocked_notification_object_parent_class = g_type_class_peek_parent (klass);
#line 50 "../src/threads/BackgroundJob.vala"
	((NotificationObjectClass *) klass)->finalize = interlocked_notification_object_finalize;
#line 50 "../src/threads/BackgroundJob.vala"
	g_type_class_adjust_private_offset (klass, &InterlockedNotificationObject_private_offset);
#line 499 "BackgroundJob.c"
}

static void
interlocked_notification_object_instance_init (InterlockedNotificationObject * self,
                                               gpointer klass)
{
	Semaphore* _tmp0_;
#line 50 "../src/threads/BackgroundJob.vala"
	self->priv = interlocked_notification_object_get_instance_private (self);
#line 51 "../src/threads/BackgroundJob.vala"
	_tmp0_ = semaphore_new ();
#line 51 "../src/threads/BackgroundJob.vala"
	self->priv->semaphore = _tmp0_;
#line 513 "BackgroundJob.c"
}

static void
interlocked_notification_object_finalize (NotificationObject * obj)
{
	InterlockedNotificationObject * self;
#line 50 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObject);
#line 51 "../src/threads/BackgroundJob.vala"
	_abstract_semaphore_unref0 (self->priv->semaphore);
#line 50 "../src/threads/BackgroundJob.vala"
	NOTIFICATION_OBJECT_CLASS (interlocked_notification_object_parent_class)->finalize (obj);
#line 526 "BackgroundJob.c"
}

static GType
interlocked_notification_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (InterlockedNotificationObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) interlocked_notification_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (InterlockedNotificationObject), 0, (GInstanceInitFunc) interlocked_notification_object_instance_init, NULL };
	GType interlocked_notification_object_type_id;
	interlocked_notification_object_type_id = g_type_register_static (TYPE_NOTIFICATION_OBJECT, "InterlockedNotificationObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	InterlockedNotificationObject_private_offset = g_type_add_instance_private (interlocked_notification_object_type_id, sizeof (InterlockedNotificationObjectPrivate));
	return interlocked_notification_object_type_id;
}

GType
interlocked_notification_object_get_type (void)
{
	static volatile gsize interlocked_notification_object_type_id__once = 0;
	if (g_once_init_enter (&interlocked_notification_object_type_id__once)) {
		GType interlocked_notification_object_type_id;
		interlocked_notification_object_type_id = interlocked_notification_object_get_type_once ();
		g_once_init_leave (&interlocked_notification_object_type_id__once, interlocked_notification_object_type_id);
	}
	return interlocked_notification_object_type_id__once;
}

static inline gpointer
background_job_get_instance_private (BackgroundJob* self)
{
	return G_STRUCT_MEMBER_P (self, BackgroundJob_private_offset);
}

gint
background_job_job_priority_compare (BackgroundJobJobPriority self,
                                     BackgroundJobJobPriority other)
{
	gint result;
#line 88 "../src/threads/BackgroundJob.vala"
	result = ((gint) other) - ((gint) self);
#line 88 "../src/threads/BackgroundJob.vala"
	return result;
#line 566 "BackgroundJob.c"
}

gint
background_job_job_priority_compare_func (void* a,
                                          void* b)
{
	gint result;
#line 92 "../src/threads/BackgroundJob.vala"
	result = ((gint) b) - ((gint) a);
#line 92 "../src/threads/BackgroundJob.vala"
	return result;
#line 578 "BackgroundJob.c"
}

static GType
background_job_job_priority_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKGROUND_JOB_JOB_PRIORITY_HIGHEST, "BACKGROUND_JOB_JOB_PRIORITY_HIGHEST", "highest"}, {BACKGROUND_JOB_JOB_PRIORITY_HIGH, "BACKGROUND_JOB_JOB_PRIORITY_HIGH", "high"}, {BACKGROUND_JOB_JOB_PRIORITY_NORMAL, "BACKGROUND_JOB_JOB_PRIORITY_NORMAL", "normal"}, {BACKGROUND_JOB_JOB_PRIORITY_LOW, "BACKGROUND_JOB_JOB_PRIORITY_LOW", "low"}, {BACKGROUND_JOB_JOB_PRIORITY_LOWEST, "BACKGROUND_JOB_JOB_PRIORITY_LOWEST", "lowest"}, {0, NULL, NULL}};
	GType background_job_job_priority_type_id;
	background_job_job_priority_type_id = g_enum_register_static ("BackgroundJobJobPriority", values);
	return background_job_job_priority_type_id;
}

GType
background_job_job_priority_get_type (void)
{
	static volatile gsize background_job_job_priority_type_id__once = 0;
	if (g_once_init_enter (&background_job_job_priority_type_id__once)) {
		GType background_job_job_priority_type_id;
		background_job_job_priority_type_id = background_job_job_priority_get_type_once ();
		g_once_init_leave (&background_job_job_priority_type_id__once, background_job_job_priority_type_id);
	}
	return background_job_job_priority_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 129 "../src/threads/BackgroundJob.vala"
	return self ? g_object_ref (self) : NULL;
#line 607 "BackgroundJob.c"
}

static gpointer
_abstract_semaphore_ref0 (gpointer self)
{
#line 133 "../src/threads/BackgroundJob.vala"
	return self ? abstract_semaphore_ref (self) : NULL;
#line 615 "BackgroundJob.c"
}

BackgroundJob*
background_job_construct (GType object_type,
                          GObject* owner,
                          CompletionCallback callback,
                          gpointer callback_target,
                          GCancellable* cancellable,
                          CancellationCallback cancellation,
                          gpointer cancellation_target,
                          AbstractSemaphore* completion_semaphore)
{
	BackgroundJob* self = NULL;
	GObject* _tmp0_;
	GCancellable* _tmp1_;
	AbstractSemaphore* _tmp2_;
#line 126 "../src/threads/BackgroundJob.vala"
	self = (BackgroundJob*) g_type_create_instance (object_type);
#line 129 "../src/threads/BackgroundJob.vala"
	_tmp0_ = _g_object_ref0 (owner);
#line 129 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->owner);
#line 129 "../src/threads/BackgroundJob.vala"
	self->priv->owner = _tmp0_;
#line 130 "../src/threads/BackgroundJob.vala"
	self->priv->callback = callback;
#line 130 "../src/threads/BackgroundJob.vala"
	self->priv->callback_target = callback_target;
#line 131 "../src/threads/BackgroundJob.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 131 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 131 "../src/threads/BackgroundJob.vala"
	self->priv->cancellable = _tmp1_;
#line 132 "../src/threads/BackgroundJob.vala"
	self->priv->cancellation = cancellation;
#line 132 "../src/threads/BackgroundJob.vala"
	self->priv->cancellation_target = cancellation_target;
#line 133 "../src/threads/BackgroundJob.vala"
	_tmp2_ = _abstract_semaphore_ref0 (completion_semaphore);
#line 133 "../src/threads/BackgroundJob.vala"
	_abstract_semaphore_unref0 (self->priv->semaphore);
#line 133 "../src/threads/BackgroundJob.vala"
	self->priv->semaphore = _tmp2_;
#line 126 "../src/threads/BackgroundJob.vala"
	return self;
#line 662 "BackgroundJob.c"
}

static void
background_job_real_execute (BackgroundJob* self)
{
#line 136 "../src/threads/BackgroundJob.vala"
	g_critical ("Type `%s' does not implement abstract method `background_job_execute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 136 "../src/threads/BackgroundJob.vala"
	return;
#line 672 "BackgroundJob.c"
}

void
background_job_execute (BackgroundJob* self)
{
	BackgroundJobClass* _klass_;
#line 136 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/threads/BackgroundJob.vala"
	_klass_ = BACKGROUND_JOB_GET_CLASS (self);
#line 136 "../src/threads/BackgroundJob.vala"
	if (_klass_->execute) {
#line 136 "../src/threads/BackgroundJob.vala"
		_klass_->execute (self);
#line 687 "BackgroundJob.c"
	}
}

static BackgroundJobJobPriority
background_job_real_get_priority (BackgroundJob* self)
{
	BackgroundJobJobPriority result;
#line 139 "../src/threads/BackgroundJob.vala"
	result = BACKGROUND_JOB_JOB_PRIORITY_NORMAL;
#line 139 "../src/threads/BackgroundJob.vala"
	return result;
#line 699 "BackgroundJob.c"
}

BackgroundJobJobPriority
background_job_get_priority (BackgroundJob* self)
{
	BackgroundJobClass* _klass_;
#line 138 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 138 "../src/threads/BackgroundJob.vala"
	_klass_ = BACKGROUND_JOB_GET_CLASS (self);
#line 138 "../src/threads/BackgroundJob.vala"
	if (_klass_->get_priority) {
#line 138 "../src/threads/BackgroundJob.vala"
		return _klass_->get_priority (self);
#line 714 "BackgroundJob.c"
	}
#line 138 "../src/threads/BackgroundJob.vala"
	return 0;
#line 718 "BackgroundJob.c"
}

gint
background_job_priority_compare_func (BackgroundJob* a,
                                      BackgroundJob* b)
{
	gint result;
#line 143 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 143 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 144 "../src/threads/BackgroundJob.vala"
	result = background_job_job_priority_compare (background_job_get_priority (a), background_job_get_priority (b));
#line 144 "../src/threads/BackgroundJob.vala"
	return result;
#line 734 "BackgroundJob.c"
}

gint64
background_job_priority_comparator (void* a,
                                    void* b)
{
	gint64 result;
#line 149 "../src/threads/BackgroundJob.vala"
	result = (gint64) background_job_priority_compare_func (G_TYPE_CHECK_INSTANCE_CAST (a, TYPE_BACKGROUND_JOB, BackgroundJob), G_TYPE_CHECK_INSTANCE_CAST (b, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 149 "../src/threads/BackgroundJob.vala"
	return result;
#line 746 "BackgroundJob.c"
}

void
background_job_set_completion_priority (BackgroundJob* self,
                                        gint priority)
{
#line 153 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/threads/BackgroundJob.vala"
	self->priv->completion_priority = priority;
#line 757 "BackgroundJob.c"
}

void
background_job_set_notification_priority (BackgroundJob* self,
                                          gint priority)
{
#line 158 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/threads/BackgroundJob.vala"
	self->priv->notification_priority = priority;
#line 768 "BackgroundJob.c"
}

void
background_job_wait_for_completion (BackgroundJob* self)
{
	AbstractSemaphore* _tmp0_;
#line 165 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 166 "../src/threads/BackgroundJob.vala"
	if (_tmp0_ != NULL) {
#line 781 "BackgroundJob.c"
		AbstractSemaphore* _tmp1_;
#line 167 "../src/threads/BackgroundJob.vala"
		_tmp1_ = self->priv->semaphore;
#line 167 "../src/threads/BackgroundJob.vala"
		abstract_semaphore_wait (_tmp1_);
#line 787 "BackgroundJob.c"
	}
}

GCancellable*
background_job_get_cancellable (BackgroundJob* self)
{
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* result;
#line 170 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->cancellable;
#line 171 "../src/threads/BackgroundJob.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 171 "../src/threads/BackgroundJob.vala"
	result = _tmp1_;
#line 171 "../src/threads/BackgroundJob.vala"
	return result;
#line 807 "BackgroundJob.c"
}

gboolean
background_job_is_cancelled (BackgroundJob* self)
{
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
	gboolean result;
#line 174 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 175 "../src/threads/BackgroundJob.vala"
	_tmp1_ = self->priv->cancellable;
#line 175 "../src/threads/BackgroundJob.vala"
	if (_tmp1_ != NULL) {
#line 822 "BackgroundJob.c"
		GCancellable* _tmp2_;
#line 175 "../src/threads/BackgroundJob.vala"
		_tmp2_ = self->priv->cancellable;
#line 175 "../src/threads/BackgroundJob.vala"
		_tmp0_ = g_cancellable_is_cancelled (_tmp2_);
#line 828 "BackgroundJob.c"
	} else {
#line 175 "../src/threads/BackgroundJob.vala"
		_tmp0_ = FALSE;
#line 832 "BackgroundJob.c"
	}
#line 175 "../src/threads/BackgroundJob.vala"
	result = _tmp0_;
#line 175 "../src/threads/BackgroundJob.vala"
	return result;
#line 838 "BackgroundJob.c"
}

void
background_job_cancel (BackgroundJob* self)
{
	GCancellable* _tmp0_;
#line 178 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->cancellable;
#line 179 "../src/threads/BackgroundJob.vala"
	if (_tmp0_ != NULL) {
#line 851 "BackgroundJob.c"
		GCancellable* _tmp1_;
#line 180 "../src/threads/BackgroundJob.vala"
		_tmp1_ = self->priv->cancellable;
#line 180 "../src/threads/BackgroundJob.vala"
		g_cancellable_cancel (_tmp1_);
#line 857 "BackgroundJob.c"
	}
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 196 "../src/threads/BackgroundJob.vala"
	return self ? background_job_ref (self) : NULL;
#line 866 "BackgroundJob.c"
}

static gboolean
_background_job_on_notify_completion_gsource_func (gpointer self)
{
	gboolean result;
	result = background_job_on_notify_completion ((BackgroundJob*) self);
#line 198 "../src/threads/BackgroundJob.vala"
	return result;
#line 876 "BackgroundJob.c"
}

void
background_job_internal_notify_completion (BackgroundJob* self)
{
	AbstractSemaphore* _tmp0_;
	gboolean _tmp2_ = FALSE;
	CompletionCallback _tmp3_;
	gpointer _tmp3__target;
	gboolean _tmp5_ = FALSE;
	BackgroundJob* _tmp7_;
#line 184 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 185 "../src/threads/BackgroundJob.vala"
	if (_tmp0_ != NULL) {
#line 894 "BackgroundJob.c"
		AbstractSemaphore* _tmp1_;
#line 186 "../src/threads/BackgroundJob.vala"
		_tmp1_ = self->priv->semaphore;
#line 186 "../src/threads/BackgroundJob.vala"
		abstract_semaphore_notify (_tmp1_);
#line 900 "BackgroundJob.c"
	}
#line 188 "../src/threads/BackgroundJob.vala"
	_tmp3_ = self->priv->callback;
#line 188 "../src/threads/BackgroundJob.vala"
	_tmp3__target = self->priv->callback_target;
#line 188 "../src/threads/BackgroundJob.vala"
	if (_tmp3_ == NULL) {
#line 908 "BackgroundJob.c"
		CancellationCallback _tmp4_;
		gpointer _tmp4__target;
#line 188 "../src/threads/BackgroundJob.vala"
		_tmp4_ = self->priv->cancellation;
#line 188 "../src/threads/BackgroundJob.vala"
		_tmp4__target = self->priv->cancellation_target;
#line 188 "../src/threads/BackgroundJob.vala"
		_tmp2_ = _tmp4_ == NULL;
#line 917 "BackgroundJob.c"
	} else {
#line 188 "../src/threads/BackgroundJob.vala"
		_tmp2_ = FALSE;
#line 921 "BackgroundJob.c"
	}
#line 188 "../src/threads/BackgroundJob.vala"
	if (_tmp2_) {
#line 189 "../src/threads/BackgroundJob.vala"
		return;
#line 927 "BackgroundJob.c"
	}
#line 191 "../src/threads/BackgroundJob.vala"
	if (background_job_is_cancelled (self)) {
#line 931 "BackgroundJob.c"
		CancellationCallback _tmp6_;
		gpointer _tmp6__target;
#line 191 "../src/threads/BackgroundJob.vala"
		_tmp6_ = self->priv->cancellation;
#line 191 "../src/threads/BackgroundJob.vala"
		_tmp6__target = self->priv->cancellation_target;
#line 191 "../src/threads/BackgroundJob.vala"
		_tmp5_ = _tmp6_ == NULL;
#line 940 "BackgroundJob.c"
	} else {
#line 191 "../src/threads/BackgroundJob.vala"
		_tmp5_ = FALSE;
#line 944 "BackgroundJob.c"
	}
#line 191 "../src/threads/BackgroundJob.vala"
	if (_tmp5_) {
#line 192 "../src/threads/BackgroundJob.vala"
		return;
#line 950 "BackgroundJob.c"
	}
#line 196 "../src/threads/BackgroundJob.vala"
	_tmp7_ = _background_job_ref0 (self);
#line 196 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->priv->self);
#line 196 "../src/threads/BackgroundJob.vala"
	self->priv->self = _tmp7_;
#line 198 "../src/threads/BackgroundJob.vala"
	g_idle_add_full (self->priv->completion_priority, _background_job_on_notify_completion_gsource_func, background_job_ref (self), background_job_unref);
#line 960 "BackgroundJob.c"
}

static gboolean
background_job_on_notify_completion (BackgroundJob* self)
{
	gboolean result;
#line 201 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "../src/threads/BackgroundJob.vala"
	if (background_job_is_cancelled (self)) {
#line 971 "BackgroundJob.c"
		CancellationCallback _tmp0_;
		gpointer _tmp0__target;
#line 207 "../src/threads/BackgroundJob.vala"
		_tmp0_ = self->priv->cancellation;
#line 207 "../src/threads/BackgroundJob.vala"
		_tmp0__target = self->priv->cancellation_target;
#line 207 "../src/threads/BackgroundJob.vala"
		if (_tmp0_ != NULL) {
#line 980 "BackgroundJob.c"
			CancellationCallback _tmp1_;
			gpointer _tmp1__target;
#line 208 "../src/threads/BackgroundJob.vala"
			_tmp1_ = self->priv->cancellation;
#line 208 "../src/threads/BackgroundJob.vala"
			_tmp1__target = self->priv->cancellation_target;
#line 208 "../src/threads/BackgroundJob.vala"
			_tmp1_ (self, _tmp1__target);
#line 989 "BackgroundJob.c"
		}
	} else {
		CompletionCallback _tmp2_;
		gpointer _tmp2__target;
#line 210 "../src/threads/BackgroundJob.vala"
		_tmp2_ = self->priv->callback;
#line 210 "../src/threads/BackgroundJob.vala"
		_tmp2__target = self->priv->callback_target;
#line 210 "../src/threads/BackgroundJob.vala"
		if (_tmp2_ != NULL) {
#line 1000 "BackgroundJob.c"
			CompletionCallback _tmp3_;
			gpointer _tmp3__target;
#line 211 "../src/threads/BackgroundJob.vala"
			_tmp3_ = self->priv->callback;
#line 211 "../src/threads/BackgroundJob.vala"
			_tmp3__target = self->priv->callback_target;
#line 211 "../src/threads/BackgroundJob.vala"
			_tmp3_ (self, _tmp3__target);
#line 1009 "BackgroundJob.c"
		}
	}
#line 215 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->priv->self);
#line 215 "../src/threads/BackgroundJob.vala"
	self->priv->self = NULL;
#line 217 "../src/threads/BackgroundJob.vala"
	result = FALSE;
#line 217 "../src/threads/BackgroundJob.vala"
	return result;
#line 1020 "BackgroundJob.c"
}

static gboolean
_background_job_on_notification_ready_gsource_func (gpointer self)
{
	gboolean result;
	result = background_job_on_notification_ready ((BackgroundJob*) self);
#line 227 "../src/threads/BackgroundJob.vala"
	return result;
#line 1030 "BackgroundJob.c"
}

static gpointer
_notification_object_ref0 (gpointer self)
{
#line 231 "../src/threads/BackgroundJob.vala"
	return self ? notification_object_ref (self) : NULL;
#line 1038 "BackgroundJob.c"
}

void
background_job_notify (BackgroundJob* self,
                       NotificationCallback callback,
                       gpointer callback_target,
                       NotificationObject* user)
{
	InterlockedNotificationObject* interlocked = NULL;
	InterlockedNotificationObject* _tmp5_;
	InterlockedNotificationObject* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 222 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (self != NULL);
#line 1053 "BackgroundJob.c"
	{
		GeeArrayList* _tmp0_;
#line 223 "../src/threads/BackgroundJob.vala"
		_tmp0_ = background_job_notify_queue;
#line 223 "../src/threads/BackgroundJob.vala"
		g_rec_mutex_lock (&__lock_background_job_background_job_notify_queue);
#line 1060 "BackgroundJob.c"
		{
			GeeArrayList* _tmp1_;
			BackgroundJobNotificationJob* _tmp2_;
			BackgroundJobNotificationJob* _tmp3_;
#line 224 "../src/threads/BackgroundJob.vala"
			_tmp1_ = background_job_notify_queue;
#line 224 "../src/threads/BackgroundJob.vala"
			_tmp2_ = background_job_notification_job_new (callback, callback_target, self, user);
#line 224 "../src/threads/BackgroundJob.vala"
			_tmp3_ = _tmp2_;
#line 224 "../src/threads/BackgroundJob.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp3_);
#line 224 "../src/threads/BackgroundJob.vala"
			_background_job_notification_job_unref0 (_tmp3_);
#line 1075 "BackgroundJob.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp4_;
#line 223 "../src/threads/BackgroundJob.vala"
			_tmp4_ = background_job_notify_queue;
#line 223 "../src/threads/BackgroundJob.vala"
			g_rec_mutex_unlock (&__lock_background_job_background_job_notify_queue);
#line 1084 "BackgroundJob.c"
		}
#line 223 "../src/threads/BackgroundJob.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/threads/BackgroundJob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 223 "../src/threads/BackgroundJob.vala"
			g_clear_error (&_inner_error0_);
#line 223 "../src/threads/BackgroundJob.vala"
			return;
#line 1094 "BackgroundJob.c"
		}
	}
#line 227 "../src/threads/BackgroundJob.vala"
	g_idle_add_full (self->priv->notification_priority, _background_job_on_notification_ready_gsource_func, background_job_ref (self), background_job_unref);
#line 231 "../src/threads/BackgroundJob.vala"
	_tmp5_ = _notification_object_ref0 (IS_INTERLOCKED_NOTIFICATION_OBJECT (user) ? ((InterlockedNotificationObject*) user) : NULL);
#line 231 "../src/threads/BackgroundJob.vala"
	interlocked = _tmp5_;
#line 232 "../src/threads/BackgroundJob.vala"
	_tmp6_ = interlocked;
#line 232 "../src/threads/BackgroundJob.vala"
	if (_tmp6_ != NULL) {
#line 1107 "BackgroundJob.c"
		InterlockedNotificationObject* _tmp7_;
#line 233 "../src/threads/BackgroundJob.vala"
		_tmp7_ = interlocked;
#line 233 "../src/threads/BackgroundJob.vala"
		interlocked_notification_object_internal_wait_for_completion (_tmp7_);
#line 1113 "BackgroundJob.c"
	}
#line 222 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (interlocked);
#line 1117 "BackgroundJob.c"
}

static gboolean
background_job_on_notification_ready (BackgroundJob* self)
{
	BackgroundJobNotificationJob* notification_job = NULL;
	BackgroundJobNotificationJob* _tmp8_;
	BackgroundJobNotificationJob* _tmp9_;
	NotificationCallback _tmp10_;
	gpointer _tmp10__target;
	BackgroundJobNotificationJob* _tmp11_;
	BackgroundJob* _tmp12_;
	BackgroundJobNotificationJob* _tmp13_;
	NotificationObject* _tmp14_;
	InterlockedNotificationObject* interlocked = NULL;
	BackgroundJobNotificationJob* _tmp15_;
	NotificationObject* _tmp16_;
	InterlockedNotificationObject* _tmp17_;
	InterlockedNotificationObject* _tmp18_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 236 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "../src/threads/BackgroundJob.vala"
	notification_job = NULL;
#line 1143 "BackgroundJob.c"
	{
		GeeArrayList* _tmp0_;
#line 240 "../src/threads/BackgroundJob.vala"
		_tmp0_ = background_job_notify_queue;
#line 240 "../src/threads/BackgroundJob.vala"
		g_rec_mutex_lock (&__lock_background_job_background_job_notify_queue);
#line 1150 "BackgroundJob.c"
		{
			GeeArrayList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
#line 241 "../src/threads/BackgroundJob.vala"
			_tmp1_ = background_job_notify_queue;
#line 241 "../src/threads/BackgroundJob.vala"
			_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 241 "../src/threads/BackgroundJob.vala"
			_tmp3_ = _tmp2_;
#line 241 "../src/threads/BackgroundJob.vala"
			if (_tmp3_ > 0) {
#line 1163 "BackgroundJob.c"
				GeeArrayList* _tmp4_;
				gpointer _tmp5_;
#line 242 "../src/threads/BackgroundJob.vala"
				_tmp4_ = background_job_notify_queue;
#line 242 "../src/threads/BackgroundJob.vala"
				_tmp5_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp4_, 0);
#line 242 "../src/threads/BackgroundJob.vala"
				_background_job_notification_job_unref0 (notification_job);
#line 242 "../src/threads/BackgroundJob.vala"
				notification_job = (BackgroundJobNotificationJob*) _tmp5_;
#line 1174 "BackgroundJob.c"
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp6_;
#line 240 "../src/threads/BackgroundJob.vala"
			_tmp6_ = background_job_notify_queue;
#line 240 "../src/threads/BackgroundJob.vala"
			g_rec_mutex_unlock (&__lock_background_job_background_job_notify_queue);
#line 1184 "BackgroundJob.c"
		}
#line 240 "../src/threads/BackgroundJob.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1188 "BackgroundJob.c"
			gboolean _tmp7_ = FALSE;
#line 240 "../src/threads/BackgroundJob.vala"
			_background_job_notification_job_unref0 (notification_job);
#line 240 "../src/threads/BackgroundJob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 240 "../src/threads/BackgroundJob.vala"
			g_clear_error (&_inner_error0_);
#line 240 "../src/threads/BackgroundJob.vala"
			return _tmp7_;
#line 1198 "BackgroundJob.c"
		}
	}
#line 244 "../src/threads/BackgroundJob.vala"
	_tmp8_ = notification_job;
#line 244 "../src/threads/BackgroundJob.vala"
	_vala_assert (_tmp8_ != NULL, "notification_job != null");
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp9_ = notification_job;
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp10_ = _tmp9_->callback;
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp10__target = _tmp9_->callback_target;
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp11_ = notification_job;
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp12_ = _tmp11_->background_job;
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp13_ = notification_job;
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp14_ = _tmp13_->user;
#line 246 "../src/threads/BackgroundJob.vala"
	_tmp10_ (_tmp12_, _tmp14_, _tmp10__target);
#line 249 "../src/threads/BackgroundJob.vala"
	_tmp15_ = notification_job;
#line 249 "../src/threads/BackgroundJob.vala"
	_tmp16_ = _tmp15_->user;
#line 249 "../src/threads/BackgroundJob.vala"
	_tmp17_ = _notification_object_ref0 (IS_INTERLOCKED_NOTIFICATION_OBJECT (_tmp16_) ? ((InterlockedNotificationObject*) _tmp16_) : NULL);
#line 249 "../src/threads/BackgroundJob.vala"
	interlocked = _tmp17_;
#line 250 "../src/threads/BackgroundJob.vala"
	_tmp18_ = interlocked;
#line 250 "../src/threads/BackgroundJob.vala"
	if (_tmp18_ != NULL) {
#line 1233 "BackgroundJob.c"
		InterlockedNotificationObject* _tmp19_;
#line 251 "../src/threads/BackgroundJob.vala"
		_tmp19_ = interlocked;
#line 251 "../src/threads/BackgroundJob.vala"
		interlocked_notification_object_internal_completed (_tmp19_);
#line 1239 "BackgroundJob.c"
	}
#line 253 "../src/threads/BackgroundJob.vala"
	result = FALSE;
#line 253 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (interlocked);
#line 253 "../src/threads/BackgroundJob.vala"
	_background_job_notification_job_unref0 (notification_job);
#line 253 "../src/threads/BackgroundJob.vala"
	return result;
#line 1249 "BackgroundJob.c"
}

static BackgroundJobNotificationJob*
background_job_notification_job_construct (GType object_type,
                                           NotificationCallback callback,
                                           gpointer callback_target,
                                           BackgroundJob* background_job,
                                           NotificationObject* user)
{
	BackgroundJobNotificationJob* self = NULL;
	BackgroundJob* _tmp0_;
	NotificationObject* _tmp1_;
#line 101 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (background_job != NULL, NULL);
#line 101 "../src/threads/BackgroundJob.vala"
	self = (BackgroundJobNotificationJob*) g_type_create_instance (object_type);
#line 103 "../src/threads/BackgroundJob.vala"
	self->callback = callback;
#line 103 "../src/threads/BackgroundJob.vala"
	self->callback_target = callback_target;
#line 104 "../src/threads/BackgroundJob.vala"
	_tmp0_ = _background_job_ref0 (background_job);
#line 104 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->background_job);
#line 104 "../src/threads/BackgroundJob.vala"
	self->background_job = _tmp0_;
#line 105 "../src/threads/BackgroundJob.vala"
	_tmp1_ = _notification_object_ref0 (user);
#line 105 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (self->user);
#line 105 "../src/threads/BackgroundJob.vala"
	self->user = _tmp1_;
#line 101 "../src/threads/BackgroundJob.vala"
	return self;
#line 1284 "BackgroundJob.c"
}

static BackgroundJobNotificationJob*
background_job_notification_job_new (NotificationCallback callback,
                                     gpointer callback_target,
                                     BackgroundJob* background_job,
                                     NotificationObject* user)
{
#line 101 "../src/threads/BackgroundJob.vala"
	return background_job_notification_job_construct (BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, callback, callback_target, background_job, user);
#line 1295 "BackgroundJob.c"
}

static void
background_job_value_notification_job_init (GValue* value)
{
#line 96 "../src/threads/BackgroundJob.vala"
	value->data[0].v_pointer = NULL;
#line 1303 "BackgroundJob.c"
}

static void
background_job_value_notification_job_free_value (GValue* value)
{
#line 96 "../src/threads/BackgroundJob.vala"
	if (value->data[0].v_pointer) {
#line 96 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_unref (value->data[0].v_pointer);
#line 1313 "BackgroundJob.c"
	}
}

static void
background_job_value_notification_job_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 96 "../src/threads/BackgroundJob.vala"
	if (src_value->data[0].v_pointer) {
#line 96 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = background_job_notification_job_ref (src_value->data[0].v_pointer);
#line 1325 "BackgroundJob.c"
	} else {
#line 96 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1329 "BackgroundJob.c"
	}
}

static gpointer
background_job_value_notification_job_peek_pointer (const GValue* value)
{
#line 96 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1338 "BackgroundJob.c"
}

static gchar*
background_job_value_notification_job_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 96 "../src/threads/BackgroundJob.vala"
	if (collect_values[0].v_pointer) {
#line 1349 "BackgroundJob.c"
		BackgroundJobNotificationJob * object;
		object = collect_values[0].v_pointer;
#line 96 "../src/threads/BackgroundJob.vala"
		if (object->parent_instance.g_class == NULL) {
#line 96 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1356 "BackgroundJob.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 96 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1360 "BackgroundJob.c"
		}
#line 96 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = background_job_notification_job_ref (object);
#line 1364 "BackgroundJob.c"
	} else {
#line 96 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1368 "BackgroundJob.c"
	}
#line 96 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1372 "BackgroundJob.c"
}

static gchar*
background_job_value_notification_job_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	BackgroundJobNotificationJob ** object_p;
	object_p = collect_values[0].v_pointer;
#line 96 "../src/threads/BackgroundJob.vala"
	if (!object_p) {
#line 96 "../src/threads/BackgroundJob.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1387 "BackgroundJob.c"
	}
#line 96 "../src/threads/BackgroundJob.vala"
	if (!value->data[0].v_pointer) {
#line 96 "../src/threads/BackgroundJob.vala"
		*object_p = NULL;
#line 1393 "BackgroundJob.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 96 "../src/threads/BackgroundJob.vala"
		*object_p = value->data[0].v_pointer;
#line 1397 "BackgroundJob.c"
	} else {
#line 96 "../src/threads/BackgroundJob.vala"
		*object_p = background_job_notification_job_ref (value->data[0].v_pointer);
#line 1401 "BackgroundJob.c"
	}
#line 96 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1405 "BackgroundJob.c"
}

static GParamSpec*
background_job_param_spec_notification_job (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	BackgroundJobParamSpecNotificationJob* spec;
#line 96 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB), NULL);
#line 96 "../src/threads/BackgroundJob.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 96 "../src/threads/BackgroundJob.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 96 "../src/threads/BackgroundJob.vala"
	return G_PARAM_SPEC (spec);
#line 1424 "BackgroundJob.c"
}

static gpointer
background_job_value_get_notification_job (const GValue* value)
{
#line 96 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB), NULL);
#line 96 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1434 "BackgroundJob.c"
}

static void
background_job_value_set_notification_job (GValue* value,
                                           gpointer v_object)
{
	BackgroundJobNotificationJob * old;
#line 96 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 96 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 96 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 96 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 96 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 96 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 96 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_ref (value->data[0].v_pointer);
#line 1456 "BackgroundJob.c"
	} else {
#line 96 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1460 "BackgroundJob.c"
	}
#line 96 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 96 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_unref (old);
#line 1466 "BackgroundJob.c"
	}
}

static void
background_job_value_take_notification_job (GValue* value,
                                            gpointer v_object)
{
	BackgroundJobNotificationJob * old;
#line 96 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 96 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 96 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 96 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 96 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 96 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 1487 "BackgroundJob.c"
	} else {
#line 96 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1491 "BackgroundJob.c"
	}
#line 96 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 96 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_unref (old);
#line 1497 "BackgroundJob.c"
	}
}

static void
background_job_notification_job_class_init (BackgroundJobNotificationJobClass * klass,
                                            gpointer klass_data)
{
#line 96 "../src/threads/BackgroundJob.vala"
	background_job_notification_job_parent_class = g_type_class_peek_parent (klass);
#line 96 "../src/threads/BackgroundJob.vala"
	((BackgroundJobNotificationJobClass *) klass)->finalize = background_job_notification_job_finalize;
#line 1509 "BackgroundJob.c"
}

static void
background_job_notification_job_instance_init (BackgroundJobNotificationJob * self,
                                               gpointer klass)
{
#line 96 "../src/threads/BackgroundJob.vala"
	self->ref_count = 1;
#line 1518 "BackgroundJob.c"
}

static void
background_job_notification_job_finalize (BackgroundJobNotificationJob * obj)
{
	BackgroundJobNotificationJob * self;
#line 96 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJob);
#line 96 "../src/threads/BackgroundJob.vala"
	g_signal_handlers_destroy (self);
#line 98 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->background_job);
#line 99 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (self->user);
#line 1533 "BackgroundJob.c"
}

static GType
background_job_notification_job_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { background_job_value_notification_job_init, background_job_value_notification_job_free_value, background_job_value_notification_job_copy_value, background_job_value_notification_job_peek_pointer, "p", background_job_value_notification_job_collect_value, "p", background_job_value_notification_job_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackgroundJobNotificationJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_job_notification_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundJobNotificationJob), 0, (GInstanceInitFunc) background_job_notification_job_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType background_job_notification_job_type_id;
	background_job_notification_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackgroundJobNotificationJob", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return background_job_notification_job_type_id;
}

static GType
background_job_notification_job_get_type (void)
{
	static volatile gsize background_job_notification_job_type_id__once = 0;
	if (g_once_init_enter (&background_job_notification_job_type_id__once)) {
		GType background_job_notification_job_type_id;
		background_job_notification_job_type_id = background_job_notification_job_get_type_once ();
		g_once_init_leave (&background_job_notification_job_type_id__once, background_job_notification_job_type_id);
	}
	return background_job_notification_job_type_id__once;
}

static gpointer
background_job_notification_job_ref (gpointer instance)
{
	BackgroundJobNotificationJob * self;
	self = instance;
#line 96 "../src/threads/BackgroundJob.vala"
	g_atomic_int_inc (&self->ref_count);
#line 96 "../src/threads/BackgroundJob.vala"
	return instance;
#line 1568 "BackgroundJob.c"
}

static void
background_job_notification_job_unref (gpointer instance)
{
	BackgroundJobNotificationJob * self;
	self = instance;
#line 96 "../src/threads/BackgroundJob.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 96 "../src/threads/BackgroundJob.vala"
		BACKGROUND_JOB_NOTIFICATION_JOB_GET_CLASS (self)->finalize (self);
#line 96 "../src/threads/BackgroundJob.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1582 "BackgroundJob.c"
	}
}

static void
value_background_job_init (GValue* value)
{
#line 78 "../src/threads/BackgroundJob.vala"
	value->data[0].v_pointer = NULL;
#line 1591 "BackgroundJob.c"
}

static void
value_background_job_free_value (GValue* value)
{
#line 78 "../src/threads/BackgroundJob.vala"
	if (value->data[0].v_pointer) {
#line 78 "../src/threads/BackgroundJob.vala"
		background_job_unref (value->data[0].v_pointer);
#line 1601 "BackgroundJob.c"
	}
}

static void
value_background_job_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 78 "../src/threads/BackgroundJob.vala"
	if (src_value->data[0].v_pointer) {
#line 78 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = background_job_ref (src_value->data[0].v_pointer);
#line 1613 "BackgroundJob.c"
	} else {
#line 78 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1617 "BackgroundJob.c"
	}
}

static gpointer
value_background_job_peek_pointer (const GValue* value)
{
#line 78 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1626 "BackgroundJob.c"
}

static gchar*
value_background_job_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 78 "../src/threads/BackgroundJob.vala"
	if (collect_values[0].v_pointer) {
#line 1637 "BackgroundJob.c"
		BackgroundJob * object;
		object = collect_values[0].v_pointer;
#line 78 "../src/threads/BackgroundJob.vala"
		if (object->parent_instance.g_class == NULL) {
#line 78 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1644 "BackgroundJob.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 78 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1648 "BackgroundJob.c"
		}
#line 78 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = background_job_ref (object);
#line 1652 "BackgroundJob.c"
	} else {
#line 78 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1656 "BackgroundJob.c"
	}
#line 78 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1660 "BackgroundJob.c"
}

static gchar*
value_background_job_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	BackgroundJob ** object_p;
	object_p = collect_values[0].v_pointer;
#line 78 "../src/threads/BackgroundJob.vala"
	if (!object_p) {
#line 78 "../src/threads/BackgroundJob.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1675 "BackgroundJob.c"
	}
#line 78 "../src/threads/BackgroundJob.vala"
	if (!value->data[0].v_pointer) {
#line 78 "../src/threads/BackgroundJob.vala"
		*object_p = NULL;
#line 1681 "BackgroundJob.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 78 "../src/threads/BackgroundJob.vala"
		*object_p = value->data[0].v_pointer;
#line 1685 "BackgroundJob.c"
	} else {
#line 78 "../src/threads/BackgroundJob.vala"
		*object_p = background_job_ref (value->data[0].v_pointer);
#line 1689 "BackgroundJob.c"
	}
#line 78 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1693 "BackgroundJob.c"
}

GParamSpec*
param_spec_background_job (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecBackgroundJob* spec;
#line 78 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKGROUND_JOB), NULL);
#line 78 "../src/threads/BackgroundJob.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 78 "../src/threads/BackgroundJob.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 78 "../src/threads/BackgroundJob.vala"
	return G_PARAM_SPEC (spec);
#line 1712 "BackgroundJob.c"
}

gpointer
value_get_background_job (const GValue* value)
{
#line 78 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB), NULL);
#line 78 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1722 "BackgroundJob.c"
}

void
value_set_background_job (GValue* value,
                          gpointer v_object)
{
	BackgroundJob * old;
#line 78 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB));
#line 78 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 78 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 78 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKGROUND_JOB));
#line 78 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 78 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 78 "../src/threads/BackgroundJob.vala"
		background_job_ref (value->data[0].v_pointer);
#line 1744 "BackgroundJob.c"
	} else {
#line 78 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1748 "BackgroundJob.c"
	}
#line 78 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 78 "../src/threads/BackgroundJob.vala"
		background_job_unref (old);
#line 1754 "BackgroundJob.c"
	}
}

void
value_take_background_job (GValue* value,
                           gpointer v_object)
{
	BackgroundJob * old;
#line 78 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB));
#line 78 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 78 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 78 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKGROUND_JOB));
#line 78 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 78 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 1775 "BackgroundJob.c"
	} else {
#line 78 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1779 "BackgroundJob.c"
	}
#line 78 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 78 "../src/threads/BackgroundJob.vala"
		background_job_unref (old);
#line 1785 "BackgroundJob.c"
	}
}

static void
background_job_class_init (BackgroundJobClass * klass,
                           gpointer klass_data)
{
	GeeArrayList* _tmp0_;
#line 78 "../src/threads/BackgroundJob.vala"
	background_job_parent_class = g_type_class_peek_parent (klass);
#line 78 "../src/threads/BackgroundJob.vala"
	((BackgroundJobClass *) klass)->finalize = background_job_finalize;
#line 78 "../src/threads/BackgroundJob.vala"
	g_type_class_adjust_private_offset (klass, &BackgroundJob_private_offset);
#line 78 "../src/threads/BackgroundJob.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) background_job_real_execute;
#line 78 "../src/threads/BackgroundJob.vala"
	((BackgroundJobClass *) klass)->get_priority = (BackgroundJobJobPriority (*) (BackgroundJob*)) background_job_real_get_priority;
#line 109 "../src/threads/BackgroundJob.vala"
	g_rec_mutex_init (&__lock_background_job_background_job_notify_queue);
#line 109 "../src/threads/BackgroundJob.vala"
	_tmp0_ = gee_array_list_new (BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, (GBoxedCopyFunc) background_job_notification_job_ref, (GDestroyNotify) background_job_notification_job_unref, NULL, NULL, NULL);
#line 109 "../src/threads/BackgroundJob.vala"
	background_job_notify_queue = _tmp0_;
#line 1810 "BackgroundJob.c"
}

static void
background_job_instance_init (BackgroundJob * self,
                              gpointer klass)
{
#line 78 "../src/threads/BackgroundJob.vala"
	self->priv = background_job_get_instance_private (self);
#line 115 "../src/threads/BackgroundJob.vala"
	self->priv->self = NULL;
#line 116 "../src/threads/BackgroundJob.vala"
	self->priv->semaphore = NULL;
#line 123 "../src/threads/BackgroundJob.vala"
	self->priv->completion_priority = G_PRIORITY_HIGH;
#line 124 "../src/threads/BackgroundJob.vala"
	self->priv->notification_priority = G_PRIORITY_DEFAULT_IDLE;
#line 78 "../src/threads/BackgroundJob.vala"
	self->ref_count = 1;
#line 1829 "BackgroundJob.c"
}

static void
background_job_finalize (BackgroundJob * obj)
{
	BackgroundJob * self;
#line 78 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKGROUND_JOB, BackgroundJob);
#line 78 "../src/threads/BackgroundJob.vala"
	g_signal_handlers_destroy (self);
#line 111 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->owner);
#line 113 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 115 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->priv->self);
#line 116 "../src/threads/BackgroundJob.vala"
	_abstract_semaphore_unref0 (self->priv->semaphore);
#line 1848 "BackgroundJob.c"
}

static GType
background_job_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_background_job_init, value_background_job_free_value, value_background_job_copy_value, value_background_job_peek_pointer, "p", value_background_job_collect_value, "p", value_background_job_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackgroundJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundJob), 0, (GInstanceInitFunc) background_job_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType background_job_type_id;
	background_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackgroundJob", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	BackgroundJob_private_offset = g_type_add_instance_private (background_job_type_id, sizeof (BackgroundJobPrivate));
	return background_job_type_id;
}

GType
background_job_get_type (void)
{
	static volatile gsize background_job_type_id__once = 0;
	if (g_once_init_enter (&background_job_type_id__once)) {
		GType background_job_type_id;
		background_job_type_id = background_job_get_type_once ();
		g_once_init_leave (&background_job_type_id__once, background_job_type_id);
	}
	return background_job_type_id__once;
}

gpointer
background_job_ref (gpointer instance)
{
	BackgroundJob * self;
	self = instance;
#line 78 "../src/threads/BackgroundJob.vala"
	g_atomic_int_inc (&self->ref_count);
#line 78 "../src/threads/BackgroundJob.vala"
	return instance;
#line 1884 "BackgroundJob.c"
}

void
background_job_unref (gpointer instance)
{
	BackgroundJob * self;
	self = instance;
#line 78 "../src/threads/BackgroundJob.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 78 "../src/threads/BackgroundJob.vala"
		BACKGROUND_JOB_GET_CLASS (self)->finalize (self);
#line 78 "../src/threads/BackgroundJob.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1898 "BackgroundJob.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

